
----------------------------------------------------------------------------------------------------------------------------
-- If checkbox 'Delete only single values' in program DbControl is set, then execute only the following command
----------------------------------------------------------------------------------------------------------------------------

DECLARE @delNumber bigint,
		@lineMessage varchar(200)

IF ('{DeleteProtocol}' = (SELECT 'True'))
BEGIN

DELETE FROM ProtocolData
FROM ProtocolData INNER JOIN MainData ON ProtocolData.FkIdent = MainData.PkIdent  
WHERE PkIdent IN (SELECT PkIdent FROM MainData {whereString} )

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table ProtocolData' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

END
ELSE
BEGIN

DELETE FROM ErrorData
FROM ErrorData INNER JOIN MainData ON ErrorData.FkIdent = MainData.PkIdent  
WHERE PkIdent IN (SELECT PkIdent FROM MainData {whereString} ) 

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table ErrorData' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

DELETE FROM ArchiveData
FROM ArchiveData INNER JOIN MainData ON ArchiveData.FkIdent = MainData.PkIdent  
WHERE PkIdent IN (SELECT PkIdent FROM MainData {whereString} )

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table ArchiveData' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

DELETE FROM AdditionalInfo
FROM AdditionalInfo INNER JOIN MainData ON AdditionalInfo.FkIdent = MainData.PkIdent  
WHERE PkIdent IN (SELECT PkIdent FROM MainData {whereString} )

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table AdditionalInfo' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

DELETE FROM ModesPerMeasurement
FROM ModesPerMeasurement INNER JOIN MainData ON ModesPerMeasurement.FkIdent = MainData.PkIdent  
WHERE PkIdent IN (SELECT PkIdent FROM MainData {whereString} )

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table ModesPerMeasurement' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

DELETE FROM ProtocolData
FROM ProtocolData INNER JOIN MainData ON ProtocolData.FkIdent = MainData.PkIdent  
WHERE PkIdent IN (SELECT PkIdent FROM MainData {whereString} )

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table ProtocolData' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

DELETE FROM MainData 
WHERE PkIdent IN (SELECT PkIdent FROM MainData {whereString} )

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table MainData' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

DELETE FROM WeeklyResultDetails  
WHERE Type IN (SELECT Id FROM TypeID WHERE Id <> 0
                EXCEPT
                SELECT DISTINCT Type FROM MainData WHERE Type IN (SELECT Id FROM TypeID WHERE Id <> 0));

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table WeeklyResultDetails' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

DELETE FROM TypeId 
WHERE Id IN (SELECT Id FROM TypeID WHERE Id <> 0
            EXCEPT
            SELECT DISTINCT Type FROM MainData WHERE Type IN (SELECT Id FROM TypeID WHERE Id <> 0));

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table TypeId' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

DELETE FROM BaseTypeID 
WHERE Id IN (SELECT Id FROM BaseTypeID WHERE Id <> 0
            EXCEPT
            SELECT DISTINCT BaseType FROM MainData WHERE BaseType IN (SELECT Id FROM BaseTypeID WHERE Id <> 0));

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table BaseTypeID' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

DELETE FROM BenchID 
WHERE Id IN (SELECT Id FROM BenchID WHERE Id <> 0
            EXCEPT
            SELECT DISTINCT TestBench FROM MainData WHERE TestBench IN (SELECT Id FROM BenchID WHERE Id <> 0)); 

-- Count number of entries that are affected by the deletion
SELECT @delNumber = @@ROWCOUNT
SELECT @lineMessage = CAST(@delNumber AS varchar) + ' number of rows were deleted from table BenchID' 
RAISERROR(@lineMessage,0,1) WITH NOWAIT

END
GO


