
----------------------------------------------------------------------------------------------------------------------------
-- If checkbox 'Setup new login' in program DbControl is set, then run this script
----------------------------------------------------------------------------------------------------------------------------

IF ('{NewLogin}' = (SELECT 'True'))
BEGIN
----------------------------------------------------------------------------------------------------------------------------
-- Add new login and grant database access
----------------------------------------------------------------------------------------------------------------------------
IF ((SELECT name FROM master.dbo.syslogins WHERE name = N'{LoginName}') IS NULL)
BEGIN
-- 1. Create the new login if it not yet exists:
	EXEC sp_addlogin N'{LoginName}', N'{LoginPwd}', N'{DbName}', '{DefLanguage}'
END
ELSE
BEGIN
	-- If checkbox 'Overwrite old password' is set then, overwrite old password and default language
	IF ('{OverwritePwd}' = (SELECT 'True'))
	BEGIN
		EXEC sp_password NULL, N'{LoginPwd}', N'{LoginName}'
		EXEC sp_defaultlanguage N'{LoginName}', '{DefLanguage}'
	END
END

-- 2. Grant access for new login {LoginName} to new database and add db_owner role to new login
IF ((SELECT name FROM {DbName}.dbo.sysusers WHERE NAME = N'{LoginName}' AND uid < 16382) IS NULL)
BEGIN
	EXEC sp_grantdbaccess N'{LoginName}', N'{LoginName}'
	EXEC sp_addrolemember 'db_owner', N'{LoginName}'
END
----------------------------------------------------------------------------------------------------------------------------
END
GO
----------------------------------------------------------------------------------------------------------------------------



