PRINT 'Starting database creation' 

IF NOT EXISTS (SELECT name FROM master.dbo.sysdatabases WHERE name = N'{DbName}')
BEGIN

CREATE DATABASE [{DbName}]
	ON PRIMARY (NAME = N'{DbName}', FILENAME = N'{DbPath}{DbName}.mdf'),
	FILEGROUP Protocol (NAME = N'{DbName}_ProtocolData', FILENAME = N'{DbPath}{DbName}_ProtocolData.ndf', MAXSIZE = UNLIMITED, FILEGROWTH = 1%)
	LOG ON (NAME = N'{DbName}_log', FILENAME = N'{DbPath}{DbName}_log.LDF', SIZE = 1, FILEGROWTH = 1%)
 COLLATE Latin1_General_CI_AS

DECLARE @version float
SELECT @version = Cast(Left(CAST(SERVERPROPERTY('ProductVersion') AS nvarchar),4) as float)

IF (@version < 11.0)
BEGIN

EXEC sp_dboption N'{DbName}', N'autoclose', N'false'
EXEC sp_dboption N'{DbName}', N'bulkcopy', N'false'
EXEC sp_dboption N'{DbName}', N'trunc. log', N'true'
EXEC sp_dboption N'{DbName}', N'trunc. log on chkpt.', N'true'
EXEC sp_dboption N'{DbName}', N'torn page detection', N'true'
EXEC sp_dboption N'{DbName}', N'read only', N'false'
EXEC sp_dboption N'{DbName}', N'dbo use only', N'false'
EXEC sp_dboption N'{DbName}', N'single user', N'false'
EXEC sp_dboption N'{DbName}', N'autoshrink', N'false'
EXEC sp_dboption N'{DbName}', N'ANSI null default', N'false'
EXEC sp_dboption N'{DbName}', N'recursive triggers', N'false'
EXEC sp_dboption N'{DbName}', N'ANSI nulls', N'false'
EXEC sp_dboption N'{DbName}', N'concat null yields null', N'false'
EXEC sp_dboption N'{DbName}', N'cursor close on commit', N'false'
EXEC sp_dboption N'{DbName}', N'default to local cursor', N'false'
EXEC sp_dboption N'{DbName}', N'quoted identifier', N'false'
EXEC sp_dboption N'{DbName}', N'ANSI warnings', N'false'
EXEC sp_dboption N'{DbName}', N'auto create statistics', N'true'
EXEC sp_dboption N'{DbName}', N'auto update statistics', N'true'

END
ELSE IF (@version >= 11.0)
BEGIN

ALTER DATABASE  {DbName} SET AUTO_CLOSE OFF
ALTER DATABASE {DbName} SET AUTO_CLOSE OFF
ALTER DATABASE {DbName} SET RECOVERY SIMPLE
ALTER DATABASE {DbName} SET TORN_PAGE_DETECTION ON 
ALTER DATABASE {DbName} SET READ_WRITE
ALTER DATABASE {DbName} SET MULTI_USER
ALTER DATABASE {DbName} SET AUTO_SHRINK OFF 
ALTER DATABASE  {DbName} SET ANSI_NULLS OFF
ALTER DATABASE {DbName} SET RECURSIVE_TRIGGERS OFF
ALTER DATABASE {DbName} SET ANSI_NULLS OFF
ALTER DATABASE {DbName} SET CONCAT_NULL_YIELDS_NULL OFF
ALTER DATABASE {DbName} SET CURSOR_CLOSE_ON_COMMIT OFF
ALTER DATABASE {DbName} SET QUOTED_IDENTIFIER OFF
ALTER DATABASE {DbName} SET ANSI_WARNINGS OFF
ALTER DATABASE {DbName} SET AUTO_CREATE_STATISTICS ON
ALTER DATABASE {DbName} SET AUTO_UPDATE_STATISTICS ON
END

PRINT 'Created database {DbPath}{DbName}.mdf' 

END
ELSE PRINT 'Database with name {DbName} already exists' 

GO