------------------------------------------------------------------------------------------------------------------------------------------
------------ Function: FilterForShift
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[FilterForShift]') AND [type] = 'TF')
	DROP FUNCTION [dbo].[FilterForShift]
GO

CREATE FUNCTION [dbo].[FilterForShift] (@ShiftId INT, @MeasureTime datetime)
RETURNS int
AS
BEGIN
DECLARE @contains INT
DECLARE @Id INT
DECLARE @ShiftMinutesInDay INT
SET @ShiftMinutesInDay = DATEPART(hh,@MeasureTime)*60 + DATEPART(mi,@MeasureTime)
SET @Id = (
SELECT ShiftNames.Id FROM ShiftNames
INNER JOIN ShiftMinutes ON ShiftNames.Id = ShiftMinutes.ShiftId
WHERE @ShiftMinutesInDay >= ShiftMinutes.Start AND @ShiftMinutesInDay < ShiftMinutes.Stop
)
SET @contains = (
CASE @ShiftId
WHEN @Id THEN 1
ELSE 0
END
)
RETURN @contains
END
GO