
------------------------------------------------------------------------------------------------------------------------------------------
------------ Function: FirstAndNErrors
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[FirstAndNErrors]') AND [type] = 'TF')
	DROP FUNCTION [dbo].[FirstAndNErrors]
GO


CREATE FUNCTION [dbo].[FirstAndNErrors] (@PkIdent INT, @TopN INT)
RETURNS  @idTable TABLE 
(
    -- columns returned by the function
    Id INT NOT NULL
)
AS
BEGIN
DECLARE @TempTable table (id INT)

-- in case of good transmissions with error entries
--IF (SELECT Result From MainData WHERE MainData.PkIdent = @PkIdent) <> 2
--BEGIN
--	INSERT INTO @TempTable 
--	SELECT - 1

--	INSERT INTO  @idTable
--	SELECT Id FROM @TempTable 
--	RETURN
--END

-- If @TopN equals 0 then fill the @TempTable with all errors associated with the respective @PkIdent
IF (@TopN) = 0
BEGIN
	INSERT INTO @TempTable 
	SELECT FkInternCode
	FROM ErrorData
	WHERE ErrorData.FkIdent = @PkIdent 
END
ELSE
BEGIN
	INSERT INTO @TempTable 
	SELECT FkInternCode
	FROM ErrorData
	WHERE ErrorData.FkIdent = @PkIdent AND ErrorData.Nr IN (SELECT TOP (@TopN) Nr FROM (SELECT DISTINCT Nr FROM ErrorData) t)
END


-- In case the above SELECT query returns NULL
IF (SELECT COUNT(*) FROM @TempTable) = 0
INSERT INTO @idTable 
SELECT -1

INSERT INTO  @idTable
SELECT Id FROM @TempTable 
RETURN

END
GO
------------------------------------------------------------------------------------------------------------------------------------------

