

------------------------------------------------------------------------------------------------------------------------------------------
------------ Function: GetShiftOffset
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[GetShiftOffset]') AND [type] = 'FN')
	DROP FUNCTION [dbo].[GetShiftOffset]
GO

CREATE FUNCTION [dbo].[GetShiftOffset](@rejectsHistory bit)
RETURNS int
AS
BEGIN

DECLARE @offset INT

IF EXISTS (SELECT * FROM ShiftMinutes WHERE [Day] > 0 OR [Day] < 0)
BEGIN
	IF EXISTS (SELECT * FROM ShiftMinutes WHERE [Day] > 0)
	BEGIN
		-- In case of the calendar week calculation for the rejects' history the offset needs to be substracted (since the current day spans to the next day)
		IF (@rejectsHistory = 1) SET @offset = -(SELECT [Stop] FROM ShiftMinutes WHERE [Day] > 0)
		ELSE SET @offset = (SELECT [Stop] FROM ShiftMinutes WHERE [Day] > 0)
	END
	ELSE 
	BEGIN
		-- In case of the calendar week calculation for the rejects' history the offset needs to be added (since the current day starts the day before)
		IF (@rejectsHistory = 1) SET @offset = (SELECT [Stop]-[Start] FROM ShiftMinutes WHERE [Day] < 0)
		ELSE SET @offset = -(SELECT [Stop]-[Start] FROM ShiftMinutes WHERE [Day] < 0)
	END
END

RETURN @offset
END
GO