
------------------------------------------------------------------------------------------------------------------------------------------
------------ Function: GetShiftTimes
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[GetShiftTimes]') AND [type] = 'FN')
	DROP FUNCTION [dbo].[GetShiftTimes]
GO

CREATE FUNCTION [dbo].[GetShiftTimes](@shiftId int)
RETURNS nvarchar(150)
AS
BEGIN

DECLARE @shiftTime nvarchar(150)
SET @shiftTime = (SELECT Name From ShiftNames WHERE Id = @shiftId)

IF EXISTS (SELECT * FROM ShiftMinutes WHERE ShiftId = @shiftId)
BEGIN
	
	SET @shiftTime += ' ('
		
	IF EXISTS (SELECT * FROM ShiftMinutes WHERE ShiftId = @shiftId AND [Day] < 0) 
	BEGIN
		SET @shiftTime += (
			SELECT FORMAT((SELECT TIMEFROMPARTS ( (SELECT FLOOR(CAST([Start] as float) / 60)
			FROM [ShiftMinutes] WHERE ShiftId = @shiftId AND [Day] < 0), (SELECT [Start] % 60
			FROM [ShiftMinutes] WHERE ShiftId = @shiftId AND [Day] < 0), 0, 0, 0 )), N'hh\:mm'))
	END

	IF EXISTS (SELECT * FROM ShiftMinutes WHERE ShiftId = @shiftId AND [Day] = 0)
	BEGIN
			IF (SELECT Start FROM ShiftMinutes WHERE ShiftId = @shiftId AND [Day] = 0) <> 0
			BEGIN
				SET @shiftTime += 
				(SELECT FORMAT((SELECT TIMEFROMPARTS ( (SELECT FLOOR(CAST([Start] as float) / 60)
				FROM [ShiftMinutes] WHERE ShiftId = @shiftId AND [Day] = 0), (SELECT [Start] % 60
				FROM [ShiftMinutes] WHERE ShiftId = @shiftId AND [Day] = 0), 0, 0, 0 )), N'hh\:mm'))
			END

			SET @shiftTime += '-'

			IF (SELECT Stop FROM ShiftMinutes WHERE ShiftId = @shiftId AND [Day] = 0) <> 0
			BEGIN
				SET @shiftTime += 
				(SELECT FORMAT((SELECT TIMEFROMPARTS ( (SELECT FLOOR(CAST([Stop] as float) / 60)
				FROM [ShiftMinutes] WHERE ShiftId = @shiftId AND [Day] = 0), (SELECT [Stop] % 60
				FROM [ShiftMinutes] WHERE ShiftId = @shiftId AND [Day] = 0), 0, 0, 0 )), N'hh\:mm'))
			END
	END

	IF EXISTS (SELECT * FROM ShiftMinutes WHERE ShiftId = @shiftId AND [Day] > 0)
	BEGIN
		SET @shiftTime += (
			SELECT FORMAT((SELECT TIMEFROMPARTS ( (SELECT FLOOR(CAST([Start] as float) / 60)
			FROM [ShiftMinutes] WHERE ShiftId = @shiftId AND [Day] > 0), (SELECT [Start] % 60
			FROM [ShiftMinutes] WHERE ShiftId = @shiftId AND [Day] > 0), 0, 0, 0 )), N'hh\:mm'))

	END
	
	SET @shiftTime += ') '

END

RETURN @shiftTime
END
GO