

------------------------------------------------------------------------------------------------------------------------------------------
------------ Function: IsoDay
------------------------------------------------------------------------------------------------------------------------------------------
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].IsoDay') AND [type] = 'FN')
DROP FUNCTION [dbo].IsoDay
GO

/*
** Return the ISO day of the week regardless of the DATEFIRST session setting so that it fitzs into ISOWeek
Monday is day 1
*/
CREATE FUNCTION IsoDay(@dtDate datetime)
RETURNS int
AS
BEGIN

DECLARE @intISOWeekdayNumber INT

-- Get the ISO week day number (Monday = 1) for our date.
SET @intISOWeekdayNumber = (((DATEPART(dw, @dtDate) - 1) + (@@DATEFIRST - 1)) % 7) + 1


RETURN (@intISOWeekdayNumber )
END
GO

PRINT 'Function added'
GO
------------------------------------------------------------------------------------------------------------------------------------------
