------------------------------------------------------------------------------------------------------------------------------------------
------------ Function: ShiftId
------------------------------------------------------------------------------------------------------------------------------------------
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[ShiftId]') AND [type] = 'FN')
	DROP FUNCTION [dbo].[ShiftId]
GO

CREATE FUNCTION [dbo].[ShiftId] 
(
	-- Add the parameters for the function here
	@MeasureTime DateTime
)
RETURNS INT
AS
BEGIN
	-- Declare the return variable here
	DECLARE @Id INT
	DECLARE @ShiftMinutesInDay INT

	SET @ShiftMinutesInDay = DATEPART(hh,@MeasureTime)*60 + DATEPART(mi,@MeasureTime)
	SET @Id = (
			SELECT ShiftNames.Id FROM ShiftNames
			INNER JOIN ShiftMinutes ON ShiftNames.Id = ShiftMinutes.ShiftId 
			WHERE @ShiftMinutesInDay >= ShiftMinutes.Start AND @ShiftMinutesInDay < ShiftMinutes.Stop
		)

	-- SET @Name = CONVERT(VARCHAR,@MeasureTime,100) + ' M: '+ CONVERT(VARCHAR,@ShiftMinutesInDay)

	-- Return the result of the function
	RETURN @Id

END
GO

PRINT 'Function added'
GO
------------------------------------------------------------------------------------------------------------------------------------------

