
------------------------------------------------------------------------------------------------------------------------------------------
------------ Function: ShiftName
------------------------------------------------------------------------------------------------------------------------------------------
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[ShiftName]') AND [type] = 'FN')
	DROP FUNCTION [dbo].[ShiftName]
GO

CREATE FUNCTION [dbo].[ShiftName] 
(
	-- Add the parameters for the function here
	@MeasureTime DateTime
)
RETURNS VARCHAR(100)
AS
BEGIN
	-- Declare the return variable here
	DECLARE @Name VARCHAR(100)
	DECLARE @ShiftMinutesInDay INT

	SET @ShiftMinutesInDay = DATEPART(hh,@MeasureTime)*60 + DATEPART(mi,@MeasureTime)
	SET @Name = (
			SELECT ShiftNames.Name FROM ShiftNames
			INNER JOIN ShiftMinutes ON ShiftNames.Id = ShiftMinutes.ShiftId 
			WHERE @ShiftMinutesInDay >= ShiftMinutes.Start AND @ShiftMinutesInDay < ShiftMinutes.Stop
		)

	-- SET @Name = CONVERT(VARCHAR,@MeasureTime,100) + ' M: '+ CONVERT(VARCHAR,@ShiftMinutesInDay)

	-- Return the result of the function
	RETURN @Name

END
GO

PRINT 'Function added'
GO
------------------------------------------------------------------------------------------------------------------------------------------
