

------------------------------------------------------------------------------------------------------------------------------------------
------------ Function: TopErrorGroup
------------------------------------------------------------------------------------------------------------------------------------------

/* -----------------TopErrorGroup------------------------------ */
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[TopErrorGroup]') AND [type] = 'FN')
	DROP FUNCTION [dbo].[TopErrorGroup]
GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Thomas Lewien
-- Create date: 2014-05-11
-- Description:	Returns error group. Will be modified by program
-- =============================================
CREATE FUNCTION [dbo].[TopErrorGroup] 
(
	-- Add the parameters for the function here
	@pkIdent int
)
RETURNS int
AS
BEGIN
	DECLARE @errorCode int
	SET @errorCode = dbo.FirstError(@pkIdent)
	DECLARE @GroupId int
	IF (@errorCode = -1) RETURN -1	-- good units


	SET @GroupId = (
		SELECT TOP 1 GroupId from dbo.AceErrorSelection
		WHERE @errorCode >= StartErrorId
		AND @errorCode <= EndErrorId
		ORDER BY GroupId ASC
	)

	
	-- Return the result of the function or -2 for all not assigned groups
	RETURN ISNULL(@GroupId,-2)

END
GO

PRINT 'Function added'
GO
------------------------------------------------------------------------------------------------------------------------------------------
