
------------------------------------------------------------------------------------------------------------------------------------------
------------ Function: fnDsDefConstraintName
------------------------------------------------------------------------------------------------------------------------------------------
-- function that returns the name of the default constraint (=0, etc) that exists on Table @table with column @column
-- example of usage : IF NOT EXISTS ( dbo.fnDsDefConstraintName ('table1', 'defColumn') ..

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[fnDsDefConstraintName]') AND [type] = 'FN')
	DROP FUNCTION [dbo].[fnDsDefConstraintName]
GO

CREATE FUNCTION [dbo].[fnDsDefConstraintName] (@table varchar(100), @column varchar (100))
RETURNS varchar (100) AS
BEGIN
	DECLARE @defaultConstraintName varchar (100)
	SELECT  @defaultConstraintName = OBJECT_NAME(cdefault) 
		from syscolumns where cdefault is not null 
		AND name = @column AND OBJECT_NAME(id) = @table 
	RETURN(@defaultConstraintName)
END
GO

PRINT 'Function added'
GO
------------------------------------------------------------------------------------------------------------------------------------------