
------------------------------------------------------------------------------------------------------------------------------------------
------------ Procedure: spInsertMainData
------------------------------------------------------------------------------------------------------------------------------------------	
-- Update to Version 2.2.0
-- Add column [TimeOfNextMeasurement] at table [MainData] and
-- update the sproc [spInsertMainData] to meet this new column

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[spInsertMainData]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[spInsertMainData]
GO

CREATE PROC [dbo].[spInsertMainData]
	@Serial 	nvarchar(256),
	@Ordinal	int,
	@Type 		int,
	@BaseType	int,
	@TypeClass	int,
	@Property	int,	
	@TestBench 	int,
	@Factory 	int,
	@Time		nvarchar(50),	
	@TestKind	int,
	@Result 	int, 
	@ThisLast	int,
	@Ident		int OUTPUT
AS

INSERT INTO MainData 

VALUES (
	@Serial,
	@Ordinal,
	@Type,
	@BaseType,
	@TypeClass,
	@Property,
	@TestBench,
	@Factory,
	CONVERT(DATETIME, @Time, 104),	
	@TestKind,
	@Result,
	@ThisLast,
	NULL
)
SELECT @Ident = @@IDENTITY
GO
------------------------------------------------------------------------------------------------------------------------------------------

PRINT 'Stored procedure added'
GO