
------------------------------------------------------------------------------------------------------------------------------------------
------------ Procedure: spCurrentRejectHourly
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[spCurrentRejectHourly]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[spCurrentRejectHourly]
GO

/* 
	
*/ 
CREATE PROCEDURE [dbo].[spCurrentRejectHourly]
(
@startTime datetime,
@endTime datetime,
@fixHourOffset int,
@GoodUnitsOut int OUTPUT,
@BadUnitsOut int OUTPUT,
@AllUnitsOut int OUTPUT
)
AS
BEGIN
SET NOCOUNT ON

SELECT
@GoodUnitsOut = SUM(dbo.HasResult(MainData.Result,1)),
@BadUnitsOut = SUM(dbo.HasResult(MainData.Result,2)),
@AllUnitsOut = COUNT(*)  FROM Maindata
INNER JOIN dbo.TypeID ON MainData.Type = TypeId.Id
WHERE
	MainData.Serial NOT IN ( SELECT [Name] FROM [ReferenceSerials])
	AND TypeID.Name NOT IN ( SELECT [Name] FROM [ReferenceTypes])
	AND (MainData.TestKind = 1)
	AND ((MainData.Time >= @startTime)  AND  (MainData.Time < @endTime))
AND
(
-- Only Test
	((MainData.ThisLast = 1) AND (MainData.Ordinal = 1) )
OR
-- First test and same as any test there after
	(
		(MainData.ThisLast = 0) AND (MainData.Ordinal = 1)
		AND  (SELECT COUNT(*) FROM  MainData e
		WHERE
		e.Serial = MainData.Serial
		AND e.Type = MainData.Type
		AND e.Time > = MainData.Time
		AND e.Time <  DATEADD(HOUR,@fixHourOffset,e.Time)
		AND e.Result <> MainData.Result) = 0
	)
OR
-- Last Test: different from test before
	(
		(MainData.Ordinal > 1) AND (MainData.ThisLast = 1) AND
		(
			-- no earlier tests of same kind
			((Select Count(*) FROM MainData o WHERE o.Serial = MainData.Serial
				AND o.Type = MainData.Type
				AND o.TestKind = MainData.TestKind
				AND o.Time < MainData.Time) = 0)
		OR  -- different from last test
			(SELECT COUNT(*) FROM  MainData e WHERE
				e.Serial = MainData.Serial
				AND e.Type = MainData.Type
				AND e.Ordinal =
				(Select Max(Ordinal) FROM MainData o   WHERE o.Serial = MainData.Serial
					AND o.Type = MainData.Type AND o.TestKind = MainData.TestKind
					AND o.Time < MainData.Time)
					AND e.Result <> MainData.Result) > 0
		)
	)
OR
-- Any test: different from test before and not different from any test thereafter
	(MainData.Ordinal > 1 AND
		(
			(
				-- no earlier tests of same kind
				(Select Count(*) FROM MainData o   WHERE o.Serial = MainData.Serial
				AND o.Type = MainData.Type
				AND o.TestKind = MainData.TestKind
				AND o.Time < MainData.Time) = 0
			
			OR  -- different from last test
				( SELECT COUNT(*) FROM  MainData e WHERE
					e.Serial = MainData.Serial
					AND e.Type = MainData.Type
					AND e.Ordinal =
					(Select Max(Ordinal) FROM MainData o   WHERE o.Serial = MainData.Serial
						AND o.Type = MainData.Type
						AND o.TestKind = MainData.TestKind
						AND o.Time < MainData.Time)
				AND e.Result <> MainData.Result)  > 0
			)
			-- no later result that is different
			AND (SELECT COUNT(*) FROM  MainData e
				WHERE e.Serial = MainData.Serial
				AND e.Type = MainData.Type
				AND e.Time > = MainData.Time
				AND e.Time <  DATEADD(HOUR,@fixHourOffset,e.Time)
				AND e.Result <> MainData.Result) = 0
		)
	)
)
END -- procedure spCurrentRejectHourly
GO
------------------------------------------------------------------------------------------------------------------------------------------

PRINT 'Stored procedure spCurrentRejectHourly added'
GO
