
------------------------------------------------------------------------------------------------------------------------------------------
------------ Procedure: spFirstTest
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[spFirstTest]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].spFirstTest
GO

/* 
	
*/ 
CREATE PROCEDURE [dbo].spFirstTest 
(
	 @startTime datetime,
	 @endTime datetime,
	 @fixDaysOffset int,
	 @GoodUnitsOut int OUTPUT,
	 @BadUnitsOut int OUTPUT,
	 @AllUnitsOut int OUTPUT

)
 AS
BEGIN

SET NOCOUNT ON
DECLARE 
	@fixWeekTime datetime

	SET @fixWeekTime   = DATEADD(day,@fixDaysOffset,@endTime)

	SELECT 
		 @GoodUnitsOut = SUM(dbo.HasResult(MainData.Result,1)), 
		 @BadUnitsOut = SUM(dbo.HasResult(MainData.Result,2)) + SUM(dbo.HasResult(MainData.Result,4)),  
		 @AllUnitsOut = COUNT(*)  FROM Maindata  
		
		INNER JOIN dbo.TypeID ON MainData.Type = TypeId.Id
		WHERE  
		MainData.Serial NOT IN ( SELECT [Name] FROM [ReferenceSerials])  
		AND TypeID.Name NOT IN ( SELECT [Name] FROM [ReferenceTypes]) 	
		AND  ((MainData.Time >= @startTime)  AND  (MainData.Time < @endTime) ) 
		AND
		(  
			MainData.Ordinal =1 
			OR (
				(SELECT Count(*) FROM MainData t
				WHERE t.Serial = MainData.Serial  AND t.Type = MainData.Type 
					AND t.Time < MainData.Time 
					AND t.TestKind = MainData.TestKind 
					AND t.Time >= @startTime AND t.time < MainData.Time )
				 = 0        
			) 
		)

		AND (MainData.TestKind = 1)



END -- procedure spFirstTest
GO
------------------------------------------------------------------------------------------------------------------------------------------

PRINT 'Stored procedure added'
GO