
------------------------------------------------------------------------------------------------------------------------------------------
------------ Procedure: spFirstTestGroup
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[spFirstTestGroup]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].spFirstTestGroup
GO

/* 
	
*/ 
CREATE PROCEDURE [dbo].spFirstTestGroup 
(
	 @startTime datetime,
	 @endTime datetime,
	 @fixDaysOffset int,
	 @weekNr int,
	 @isUpdate int		-- --0: insert, 1: update
)
 AS
BEGIN

SET NOCOUNT ON
DECLARE 
	@fixWeekTime datetime,
	@thisCountType int

	DECLARE @TempDetails TABLE 
	(
			[WeekNr]		[int]		NOT NULL,
			[Type]			[int]		NOT NULL,	
			[TestBench]		[int]		NOT NULL,	
			[CountType]		[int]		NOT NULL,	
			[All]			[int]		NULL,
			[Good]			[int]		NULL,
			[Bad]			[int]		NULL
	)
	
	
	SELECT @thisCountType = [Id] FROM [dbo].[ResultCountType] WHERE [Name] = 'First'

	SET @fixWeekTime   = DATEADD(day,@fixDaysOffset,@endTime)

	INSERT INTO @TempDetails (
		[WeekNr], 
		[Type],		
		[TestBench],	
		[CountType],	
		[All],		
		[Good],		
		[Bad]
	)		

	SELECT 
		@weekNr,
		t.Id,
		b.Id,
		@thisCountType,
		COUNT(*),  
		SUM(dbo.HasResult(MainData.Result,1)), 
		SUM(dbo.HasResult(MainData.Result,2)) + SUM(dbo.HasResult(MainData.Result,4)) 
	FROM 
		Maindata  
		INNER JOIN dbo.TypeID t ON MainData.Type = t.Id
		INNER JOIN dbo.BenchId b ON MainData.TestBench = b.Id
	WHERE  
 		t.Id > 0 AND b.Id > 0 -- not the '*' entries
		AND MainData.Serial NOT IN ( SELECT [Name] FROM [ReferenceSerials])  
		AND (MainData.TestKind = 1)
		AND t.Name NOT IN ( SELECT [Name] FROM [ReferenceTypes]) 	
		AND  ((MainData.Time >= @startTime)  AND  (MainData.Time < @endTime) ) 
		AND
		(  
			MainData.Ordinal =1 
			OR (
				(SELECT Count(*) FROM MainData t
				WHERE t.Serial = MainData.Serial  AND t.Type = MainData.Type 
					AND t.Time < MainData.Time 
					AND t.TestKind = MainData.TestKind 
					AND t.Time >= @startTime AND t.time < MainData.Time )
				 = 0        
			) 
		)

	GROUP BY t.Id, b.Id WITH ROLLUP -- cube
	HAVING GROUPING (t.Id) = 0 AND  GROUPING (b.Id) = 0 -- avoid null entries
	
	IF (@isUpdate = 1)
	BEGIN
		BEGIN TRAN
			DELETE FROM [WeeklyResultDetails] WHERE [WeeklyResultDetails].[WeekNr] = @weekNr AND [CountType] = @thisCountType
	 		INSERT INTO [WeeklyResultDetails] SELECT * FROM @TempDetails	
		COMMIT
	END ELSE
		INSERT INTO [WeeklyResultDetails] SELECT * FROM @TempDetails	
	
		
END -- procedure spFirstTestGroup
GO
------------------------------------------------------------------------------------------------------------------------------------------

PRINT 'Stored procedure added'
GO