
------------------------------------------------------------------------------------------------------------------------------------------
------------ Procedure: spLastTest
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[spLastTest]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].spLastTest
GO

/* 
	
*/ 
CREATE PROCEDURE [dbo].spLastTest 
(
	 @startTime datetime,
	 @endTime datetime,
	 @fixDaysOffset int,
	 @GoodUnitsOut int OUTPUT,
	 @BadUnitsOut int OUTPUT,
	 @AllUnitsOut int OUTPUT

)
 AS
BEGIN

SET NOCOUNT ON
DECLARE 
	@fixWeekTime datetime

	SET @fixWeekTime   = DATEADD(day,@fixDaysOffset,@endTime)

	SELECT 
		 @GoodUnitsOut = SUM(dbo.HasResult(MainData.Result,1)), 
		 @BadUnitsOut = SUM(dbo.HasResult(MainData.Result,2)) + SUM(dbo.HasResult(MainData.Result,4)),  
		 @AllUnitsOut = COUNT(*)  FROM Maindata  
		
		INNER JOIN dbo.TypeID ON MainData.Type = TypeId.Id
		WHERE  
		MainData.Serial NOT IN ( SELECT [Name] FROM [ReferenceSerials])  
		AND TypeID.Name NOT IN ( SELECT [Name] FROM [ReferenceTypes]) 	
		AND (MainData.TestKind = 1)
		AND  ((MainData.Time >= @startTime)  AND  (MainData.Time < @endTime) ) 
		AND  (  (MainData.TimeOfNextMeasurement IS NULL) OR (MainData.TimeOfNextMeasurement > @fixWeekTime) ) 


END -- procedure spLastTest
GO
------------------------------------------------------------------------------------------------------------------------------------------

PRINT 'Stored procedure added'
GO