

------------------------------------------------------------------------------------------------------------------------------------------
------------ Procedure: spShortErrorReportOfSerial
------------------------------------------------------------------------------------------------------------------------------------------
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[spShortErrorReportOfSerial]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[spShortErrorReportOfSerial]
GO

CREATE PROC [dbo].[spShortErrorReportOfSerial]
	@serial		nvarchar (200),
	@onlyLast	int,
	@showCategories	int

AS

-- ShowCategories? Only the last entry?
DECLARE @errorCondition nvarchar (100)
DECLARE @onlyLastCondition nvarchar (100)

SET @errorCondition = ''
IF @showCategories = 0
BEGIN
  SET @errorCondition = N'
	 ErrorCode AS ErrorCode,
	 ErrorText AS ErrorText,'
END
ELSE
BEGIN
  SET @errorCondition = N'
	 ErrorCategoryCode AS ErrorCode,
	 ErrorCategoryText AS ErrorText,'
END

SET @onlyLastCondition = ''
IF @onlyLast = 1
BEGIN
  SET @onlyLastCondition = N'
	 AND [ThisLast] = 1'
END

-- @query definieren
DECLARE @query nvarchar (4000)
SET @query = N'
	SELECT
	 TestBench,
	 Type,
	 BaseType,
	 Serial,
	 [Time],'
       + @errorCondition
       + N'
	 Mode,
	 Value,
	 Limit,
	 Unit,
	 Instrument,
	 Channel,
	 Position
	FROM [vwShortErrorReport]
	WHERE [Serial] = @serial'
      + @onlyLastCondition
       + N'
	ORDER BY TestBench, Type, [Time], Nr'


-- @query ausfhren
EXEC sp_executesql @query,

	-- 1. Parameter deklarieren
      N'@serial		nvarchar (200),
	@onlyLast	int,
	@showCategories	int',

        -- 2. Werte bergeben
	@serial,
	@onlyLast,
	@showCategories
GO
------------------------------------------------------------------------------------------------------------------------------------------

PRINT 'Stored procedure added'
GO