
------------------------------------------------------------------------------------------------------------------------------------------
------------ Procedure: SpGmkResultOfOfSerial
------------------------------------------------------------------------------------------------------------------------------------------
-- [SpGmkResultOfOfSerial]
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpGmkResultOfOfSerial]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SpGmkResultOfOfSerial]
GO

CREATE PROC [dbo].[SpGmkResultOfOfSerial]
	@serial		nvarchar (200),			-- serial number
	@whichTest	int					    -- 0: All tests, -1: The last test, else the specific test
AS


DECLARE @whichTestCondition nvarchar (100)

-- WhichTest

IF @whichTest = -1	-- Last Test
BEGIN
  SET @whichTestCondition = N'
	 AND [ThisLast] = 1'
END
ELSE IF @whichTest = 0  --All tests
BEGIN
SET @whichTestCondition = ''
END
ELSE
BEGIN
SET @whichTestCondition = N'
	 AND [NTest] = ' + CONVERT(char(15),@whichTest)
END



-- Define Query
DECLARE @query nvarchar (4000)


	SET @query = N'
		SELECT
		 MainData.[Ordinal]		AS NTest,
		 MainData.[Result]		AS ResultIdx,
		 ResultId.[Text]		AS ResultTxt
		FROM  MainData
		INNER JOIN ResultId 		ON ResultId.[id] = MainData.[Result]
	WHERE  MainData.[Serial] = @serial'
      + @whichTestCondition
      + N'
	ORDER BY NTest'


-- execute @query
EXEC sp_executesql @query,

	-- 1. Parameter deklarieren
    N'@serial		nvarchar (200),
	@whichTest	int',
        -- 2. Werte bergeben
	@serial,
	@whichTest
GO
------------------------------------------------------------------------------------------------------------------------------------------

PRINT 'Stored procedure added'
GO