

------------------------------------------------------------------------------------------------------------------------------------------
------------ Procedure: spTestRollup
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[spTestRollup]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].spTestRollup
GO

/* 
	
*/ 
CREATE PROCEDURE [dbo].spTestRollup 
(
	 @weekNr int
)
 AS
BEGIN

SET NOCOUNT ON

	-- sum of all types per bench
	INSERT INTO [WeeklyResultDetails] (
			[WeekNr], 
			[Type],		
			[TestBench],	
			[CountType],	
			[All],		
			[Good],		
			[Bad]
	)	
	SELECT
		@weekNr,
		0,			-- insert all Types
		b.Id,
		rc.Id,		
		SUM([All]), 
		SUM([Good]), 
		SUM([Bad]) 
		FROM [WeeklyResultDetails] w
		INNER JOIN dbo.BenchId b ON w.[TestBench] = b.Id
		INNER JOIN dbo.[ResultCountType] rc ON w.[CountType] = rc.[Id]

		WHERE
		w.[WeekNr] = @weekNr AND w.[Type] > 0 AND w.[TestBench] > 0
		AND b.Id > 0 -- not the '*' entries


		GROUP BY b.Id, rc.Id WITH ROLLUP -- cube
		HAVING GROUPING (b.Id) = 0 AND  GROUPING (rc.Id) = 0 -- avoid null entries
	

	
	-- sum of all benches per type
	INSERT INTO [WeeklyResultDetails] (
			[WeekNr], 
			[Type],		
			[TestBench],	
			[CountType],	
			[All],		
			[Good],		
			[Bad]
	)	
	SELECT
		@weekNr,
		t.Id,			
		0,			-- insert all Benches
		rc.Id,		
		SUM([All]), 
		SUM([Good]), 
		SUM([Bad]) 
		FROM [WeeklyResultDetails] w
		INNER JOIN dbo.TypeID t ON w.[Type] = t.Id
		INNER JOIN dbo.[ResultCountType] rc ON w.[CountType] = rc.[Id]

		WHERE
		w.[WeekNr] = @weekNr AND w.[Type] > 0 AND w.[TestBench] > 0
		AND t.Id > 0 -- not the '*' entries


		GROUP BY t.Id, rc.Id WITH ROLLUP -- cube
		HAVING GROUPING (t.Id) = 0 AND  GROUPING (rc.Id) = 0 -- avoid null entries

	

		
	-- sum of all benches and all types
	INSERT INTO [WeeklyResultDetails] (
			[WeekNr], 
			[Type],		
			[TestBench],	
			[CountType],	
			[All],		
			[Good],		
			[Bad]
	)	
	SELECT
		@weekNr,
		0,			-- insert all Types
		0,			-- insert all Benches
		rc.Id,		
		SUM([All]), 
		SUM([Good]), 
		SUM([Bad]) 
		FROM [WeeklyResultDetails] w
		INNER JOIN dbo.[ResultCountType] rc ON w.[CountType] = rc.[Id]

		WHERE
		w.[WeekNr] = @weekNr AND w.[Type] = 0 AND w.[TestBench] > 0		-- add all test sums

		GROUP BY rc.Id WITH ROLLUP -- cube
		HAVING  GROUPING (rc.Id) = 0 -- avoid null entries

END -- procedure spTestRollup
GO
------------------------------------------------------------------------------------------------------------------------------------------

PRINT 'Stored procedure added'
GO