
------------------------------------------------------------------------------------------------------------------------------------------
------------ Procedure: SpDsDropAllConstraintsOfTable
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[SpDsDropAllConstraintsOfTable]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[spDsDropAllConstraintsOfTable]
GO

CREATE PROCEDURE [dbo].[spDsDropAllConstraintsOfTable] (@table varchar(100), @database varchar (100)) AS
BEGIN

	DECLARE @schema nvarchar(128), @tbl nvarchar(128), @constraint nvarchar(128) 
	DECLARE @sql nvarchar(255) 

	DECLARE cur CURSOR FAST_FORWARD FOR 
		SELECT DISTINCT cu.CONSTRAINT_SCHEMA, cu.TABLE_NAME, cu.CONSTRAINT_NAME 
		FROM information_schema.table_constraints tc 
		JOIN information_schema.referential_constraints rc ON rc.unique_constraint_name = tc.constraint_name 
		JOIN information_schema.constraint_column_usage cu ON cu.constraint_name = rc.constraint_name 
		WHERE tc.constraint_catalog = @database AND tc.table_name = @table 

	OPEN cur 
	FETCH NEXT FROM cur INTO @schema, @tbl, @constraint 
	WHILE @@fetch_status <> -1 
	BEGIN 
		SELECT @sql = 'ALTER TABLE ' + @schema + '.' + @tbl + ' DROP CONSTRAINT ' + @constraint 
		EXEC sp_executesql @sql 
		FETCH NEXT FROM cur INTO @schema, @tbl, @constraint 
	END 
	CLOSE cur 
	DEALLOCATE cur 

END
GO
------------------------------------------------------------------------------------------------------------------------------------------

PRINT 'Stored procedure added'
GO