
------------------------------------------------------------------------------------------------------------------------------------------
------------ Procedure: spDsPurgeTables
------------------------------------------------------------------------------------------------------------------------------------------
-- drop all tables that are like tableMask.
-- example: EXECUTE spPurgeTables @tableMask = 'Pola%'

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[spDsPurgeTables]') AND OBJECTPROPERTY(id, N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[spDsPurgeTables]
GO

CREATE PROCEDURE [dbo].[spDsPurgeTables] (@tableMask varchar(50)) AS
BEGIN
	if (SELECT COUNT ( * ) from dbo.sysobjects where OBJECTPROPERTY(id, N'IsUserTable') = 1 
		and NAME like @tableMask ) >0
	BEGIN
		DECLARE @table_name varchar(500), @nrTables int
		
		SELECT @nrTables = count ( * ) from dbo.sysobjects where OBJECTPROPERTY(id, N'IsUserTable') = 1 and name like @tableMask
	
		PRINT 'Deleting	' +  CONVERT(char(8),@nrTables) + @tableMask + ' temp tables' 
	
		DECLARE table_cursor CURSOR FOR 
		SELECT NAME 
		FROM dbo.sysobjects where OBJECTPROPERTY(id, N'IsUserTable') = 1 and NAME like @tableMask
	
		OPEN table_cursor
		FETCH NEXT FROM table_cursor INTO @table_name
		
		WHILE @@FETCH_STATUS = 0
		BEGIN
	
			PRINT 'Drop Table' + @table_name
			EXEC ('DROP TABLE ' + @table_name)
		
    	-- Get the next line.
	 	FETCH NEXT FROM table_cursor INTO @table_name
	
		END
	
		CLOSE table_cursor
		DEALLOCATE table_cursor
	
	END ELSE
	BEGIN
	 	PRINT 'Check OK: Nox ' + @tableMask + ' Temp tables in database'
	END 
END 
GO
------------------------------------------------------------------------------------------------------------------------------------------

PRINT 'Stored procedure added'
GO