
------------------------------------------------------------------------------------------------------------------------------------------
------------ AceErrorSelection: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[AceErrorSelection]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
CREATE TABLE [dbo].[AceErrorSelection] (
			[GroupId]			[int]	NOT NULL,  -- Id of error selection group
			[Nr]				[int]	NOT NULL,  -- Nr of entry
			[StartErrorId]		[int]	NOT NULL,  -- start of error id that belongs to this group
			[EndErrorId]		[int]	NOT NULL   -- end of error id that belongs to this group
		) ON [PRIMARY]

PRINT 'Table AceErrorSelection added'
END
ELSE PRINT 'Table AceErrorSelection already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ AceErrorSelection: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'PK_AceErrorSelection')
BEGIN
	ALTER TABLE [dbo].[AceErrorSelection] ADD CONSTRAINT [PK_AceErrorSelection] PRIMARY KEY CLUSTERED 
			(
				[GroupId] ASC,
				[Nr] ASC				
			)
PRINT 'Table constraint PK_AceErrorSelection added'
END
ELSE PRINT 'Table constraint PK_AceErrorSelection already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

