
------------------------------------------------------------------------------------------------------------------------------------------
------------ AdditionalInfo: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[AdditionalInfo]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
  CREATE TABLE [dbo].[AdditionalInfo] (
		[FkIdent]	[int]	NOT NULL, 	-- Nummer der Messung
		[KeyId]		[int]	NOT NULL,  	-- Nummer des Info-Schlssels
		[ValueId]	[int]	NOT NULL   	-- Nummer des Info-Werts
	) ON [PRIMARY]

PRINT 'Table AdditionalInfo added'
END
ELSE PRINT 'Table AdditionalInfo already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ AdditionalInfo: Check index existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM sysindexes WHERE name = N'CIdx_AdditionalInfo')
BEGIN
 	CREATE CLUSTERED INDEX [CIdx_AdditionalInfo] ON [dbo].[AdditionalInfo] ([FkIdent]) ON [PRIMARY]

PRINT 'Clustered index CIdx_AdditionalInfo added'
END
ELSE PRINT 'Clustered index CIdx_AdditionalInfo already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ AdditionalInfo: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'UQ_AdditionalInfo')
BEGIN
	ALTER TABLE [dbo].[AdditionalInfo] WITH NOCHECK ADD CONSTRAINT [UQ_AdditionalInfo] UNIQUE 
	(
		[FkIdent],
		[KeyId]
	) ON [PRIMARY]

PRINT 'Table constraint UQ_AdditionalInfo added'
END
ELSE PRINT 'Table constraint UQ_AdditionalInfo already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
