
------------------------------------------------------------------------------------------------------------------------------------------
------------ BackupMedium: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[BackupMedium]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[BackupMedium] (
		[Id]		[int]		NOT NULL	PRIMARY KEY  CLUSTERED,
		[ArchiveName]	[nvarchar] (200) NULL,
		[ArchivePath]	[nvarchar] (200) NULL,
		[StartTime]	[datetime]	NOT NULL,
		[EndTime]	[datetime]	NOT NULL,
		[ExecuteNext]	[int]		NOT NULL,
		[IsArchived]	[int]		NOT NULL,	
		[IsOnMedium]	[int]		NOT NULL,
		[MediumName]	[nvarchar] (200) NULL,
		[Remarks]	[nvarchar] (200) NULL
	) ON [PRIMARY]

	PRINT 'Table BackupMedium added'
END
ELSE PRINT 'Table BackupMedium already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BackupMedium: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT dbo.fnDsDefConstraintName('BackupMedium','StartTime')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[BackupMedium] WITH NOCHECK
	ADD CONSTRAINT [DF_BackupMedium_StartTime] 	DEFAULT (CONVERT(DATETIME, '01.01.2001 00:00:00', 104)) FOR [StartTime]

PRINT 'Table constraint DF_BackupMedium_StartTime added'
END
ELSE PRINT 'Table constraint DF_BackupMedium_StartTime already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT dbo.fnDsDefConstraintName('BackupMedium','EndTime')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[BackupMedium] WITH NOCHECK
	ADD CONSTRAINT [DF_BackupMedium_EndTime] DEFAULT (CONVERT(DATETIME, '01.01.2001 00:00:00', 104)) FOR [EndTime]

PRINT 'Table constraint DF_BackupMedium_EndTime added'
END
ELSE PRINT 'Table constraint DF_BackupMedium_EndTime already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT dbo.fnDsDefConstraintName('BackupMedium','IsArchived')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[BackupMedium] WITH NOCHECK
	ADD CONSTRAINT [DF_BackupMedium_IsArchived] DEFAULT (0) FOR [IsArchived]

PRINT 'Table constraint DF_BackupMedium_IsArchived added'
END
ELSE PRINT 'Table constraint DF_BackupMedium_IsArchived already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT dbo.fnDsDefConstraintName('BackupMedium','ExecuteNext')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[BackupMedium] WITH NOCHECK
	ADD CONSTRAINT [DF_BackupMedium_ExecuteNext] DEFAULT (0) FOR [ExecuteNext]

PRINT 'Table constraint DF_BackupMedium_ExecuteNext added'
END
ELSE PRINT 'Table constraint DF_BackupMedium_ExecuteNext already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT dbo.fnDsDefConstraintName('BackupMedium','IsOnMedium')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[BackupMedium] WITH NOCHECK
	ADD CONSTRAINT [DF_BackupMedium_IsOnMedium] DEFAULT (0) FOR [IsOnMedium]

PRINT 'Table constraint DF_BackupMedium_IsOnMedium added'
END
ELSE PRINT 'Table constraint DF_BackupMedium_IsOnMedium already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------