------------------------------------------------------------------------------------------------------------------------------------------
------------ BaseTypeId: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[BaseTypeId]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	CREATE TABLE [dbo].[BaseTypeId] (
	[Id]		[int]		PRIMARY KEY  CLUSTERED NOT NULL IDENTITY(0, 1),
	[Text]		[nvarchar] (80)	COLLATE Latin1_General_CI_AS NULL,
	[TypeClass]	[int]		NULL 	) ON [PRIMARY]

PRINT 'Table BaseTypeId added'
END
ELSE PRINT 'Table BaseTypeId already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BaseTypeId: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT CONSTRAINT_NAME from INFORMATION_SCHEMA.KEY_COLUMN_USAGE WHERE TABLE_NAME ='BaseTypeId' AND COLUMN_NAME = 'Id')
BEGIN
	-- BaseTypeId  Check Primary Key, else create. Assumes that the BaseTypeId index is Pk_BaseTypeId
	ALTER TABLE [dbo].[BaseTypeId] WITH NOCHECK 
	ADD CONSTRAINT [Pk_BaseTypeId] PRIMARY KEY CLUSTERED([Id]) ON [PRIMARY] 

PRINT 'Primary key clustered on ID of Table BaseTypeId added'
END
ELSE PRINT 'Primary key clustered on ID of Table BaseTypeId already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT dbo.fnDsDefConstraintName('BaseTypeId','TypeClass')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[BaseTypeId] ADD CONSTRAINT [DF_BaseTypeID_TypeClass] DEFAULT (0) FOR TypeClass

PRINT 'Table constraint DF_BaseTypeID_TypeClass added'
END
ELSE PRINT 'Table constraint DF_BaseTypeID_TypeClass already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

