------------------------------------------------------------------------------------------------------------------------------------------
------------ BenchId: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[BenchId]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[BenchId] (
		[Id]		[int]		PRIMARY KEY  CLUSTERED NOT NULL,
		[Name]		[nvarchar] (50)	COLLATE Latin1_General_CI_AS NULL,
		[LongName]	[nvarchar] (50)	COLLATE Latin1_General_CI_AS NULL,
		[BenchGroup]	[int]		NOT NULL 
	) ON [PRIMARY]

PRINT 'Table BenchID added'
END
ELSE PRINT 'Table BenchID already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BenchId: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT CONSTRAINT_NAME from INFORMATION_SCHEMA.KEY_COLUMN_USAGE WHERE TABLE_NAME ='BenchId' AND COLUMN_NAME = 'Id')
BEGIN
	------------ BenchId: Check Primary Key, else create. Assumes that the BenchId index is Pk_BenchId
	ALTER TABLE [dbo].[BenchId] WITH NOCHECK ADD 
		CONSTRAINT [Pk_BenchId] PRIMARY KEY CLUSTERED ([Id]) ON [PRIMARY] 

PRINT 'Table constraint Pk_BenchId added'
END
ELSE PRINT 'Table constraint Pk_BenchId already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BenchId: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT dbo.fnDsDefConstraintName('BenchID','BenchGroup')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[BenchId] WITH NOCHECK 
	ADD CONSTRAINT [DF_BenchID_BenchGroup] DEFAULT (0) FOR [BenchGroup]

PRINT 'Table constraint DF_BenchID_BenchGroup added'
END
ELSE PRINT 'Table constraint DF_BenchID_BenchGroup already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

