
------------------------------------------------------------------------------------------------------------------------------------------
------------ BlobData: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[BlobData]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
  CREATE TABLE [dbo].[BlobData] (
		[FKident]	[int]	NOT NULL,
		[BlobType]	[int]	NOT NULL,
		[BlobLen]	[int]	NULL,
		[BlobData]	[image]	NULL 
	) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

PRINT 'Table BlobData added'
END
ELSE PRINT 'Table BlobData already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ AdditionalInfo: Check index existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM sysindexes WHERE name = N'CIdx_BlobData')
BEGIN
 	CREATE CLUSTERED INDEX [CIdx_BlobData] ON [dbo].[BlobData] ([FkIdent]) ON [PRIMARY]

PRINT 'Clustered index CIdx_BlobData added'
END
ELSE PRINT 'Clustered index CIdx_BlobData already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

