
------------------------------------------------------------------------------------------------------------------------------------------
------------ BlobInfo: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[BlobInfo]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[BlobInfo] (
		[FkIdent]	[int] NOT NULL,
		[BlobType]	[int] NOT NULL,
		[BackupStatus]	[int] NOT NULL,
		[BackupMedium]	[int] NOT NULL 
	) ON [PRIMARY]

PRINT 'Table BlobInfo added' 
END
ELSE PRINT 'Table BlobInfo already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BlobInfo: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT dbo.fnDsDefConstraintName('BlobInfo','BlobType')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[BlobInfo] WITH NOCHECK
	ADD CONSTRAINT [DF_BlobInfo_BlobType] DEFAULT (0) FOR [BlobType]

PRINT 'Table constraint DF_BlobInfo_BlobType added'
END
ELSE PRINT 'Table constraint DF_BlobInfo_BlobType already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT dbo.fnDsDefConstraintName('BlobInfo','BackupStatus')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[BlobInfo] WITH NOCHECK
	ADD CONSTRAINT [DF_BlobInfo_BackupStatus] DEFAULT (0) FOR [BackupStatus]

PRINT 'Table constraint DF_BlobInfo_BackupStatus added'
END
ELSE PRINT 'Table constraint DF_BlobInfo_BackupStatus already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT dbo.fnDsDefConstraintName('BlobInfo','BackupMedium')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[BlobInfo] WITH NOCHECK
	ADD CONSTRAINT [DF_BlobInfo_BackupMedium] DEFAULT (0) FOR [BackupMedium]

PRINT 'Table constraint DF_BlobInfo_BackupMedium added'
END
ELSE PRINT 'Table constraint DF_BlobInfo_BackupMedium already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
