
------------------------------------------------------------------------------------------------------------------------------------------
------------ BlobStatus: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[BlobStatus]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	CREATE TABLE [dbo].[BlobStatus] (
		[Id]	[int]		PRIMARY KEY CLUSTERED NOT NULL,
		[Text]	[nvarchar] (50)	NULL 
	) ON [PRIMARY]

PRINT 'Table BlobStatus added'
END
ELSE PRINT 'Table BlobStatus already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BlobStatus: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT CONSTRAINT_NAME from INFORMATION_SCHEMA.KEY_COLUMN_USAGE WHERE TABLE_NAME ='BlobStatus' AND COLUMN_NAME = 'Id')
BEGIN
	------------ BlobType Check Primary Key, else create. Assumes that the BlobType index is Pk_BlobType
	ALTER TABLE [dbo].[BlobStatus] WITH NOCHECK 
	ADD CONSTRAINT [Pk_BlobStatus] PRIMARY KEY CLUSTERED ([Id]) ON [PRIMARY] 

PRINT 'Table constraint Pk_BlobStatus added'
END
ELSE PRINT 'Table constraint Pk_BlobStatus already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

