
------------------------------------------------------------------------------------------------------------------------------------------
------------ BlobType: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[BlobType]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	CREATE TABLE [dbo].[BlobType] (
		[Id]	[int]		PRIMARY KEY  CLUSTERED NOT NULL,
		[Text]	[nvarchar] (80) COLLATE Latin1_General_CI_AS NULL 
	) ON [PRIMARY]

PRINT 'Table BlobType added'
END
ELSE PRINT 'Table BlobType already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BlobType: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT CONSTRAINT_NAME from INFORMATION_SCHEMA.KEY_COLUMN_USAGE WHERE TABLE_NAME ='BlobType' AND COLUMN_NAME = 'Id')
BEGIN
	------------ BlobType Check Primary Key, else create. Assumes that the BlobType index is Pk_BlobType
	ALTER TABLE [dbo].[BlobType] WITH NOCHECK 
	ADD CONSTRAINT [Pk_BlobType] PRIMARY KEY  CLUSTERED ([Id]) ON [PRIMARY] 

PRINT 'Table constraint Pk_BlobType added'
END
ELSE PRINT 'Table constraint Pk_BlobType already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

