
------------------------------------------------------------------------------------------------------------------------------------------
------------ DeleteLog: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
-- Table DeleteLog contains the log info of the procedure DeleteData (CleanupDb)
if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DeleteLog]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

DECLARE @count int
SELECT @count = (SELECT Count(Id) FROM DeleteLog)

-- If table is empty, drop and recreate it
IF (@count = 0) BEGIN

	DROP TABLE [dbo].[DeleteLog]

	CREATE TABLE [dbo].[DeleteLog] (
		[Id] [int] IDENTITY , 
		[Day] [datetime] NOT NULL ,
		[TimeLimit] [datetime] ,
		[Duration] [time] ,
		[Type] [int] ,
		[Bench] [int] ,
		[DeletedMain] [int] ,
		[DeletedProtocol] [int] ,
		[ErrorId] [int] 
)	ON [PRIMARY]

END 
ELSE 
BEGIN 
	PRINT 'Table DeleteLog with entries already exists.'
	IF ((SELECT name FROM sys.columns WHERE object_id = (SELECT object_id FROM sys.objects WHERE name = 'DeleteLog') AND name = 'Bench') IS NULL)
	BEGIN
		ALTER TABLE [DeleteLog]
		ADD Bench int  
	END
END
END
------------------------------------------------------------------------------------------------------------------------------------------
-- if table does not exist, create new
ELSE BEGIN

	CREATE TABLE [dbo].[DeleteLog] (
		[Id] [int] IDENTITY , 
		[Day] [datetime] NOT NULL ,
		[TimeLimit] [datetime] ,
		[Duration] [time] ,
		[Type] [int] ,
		[Bench] [int] ,
		[DeletedMain] [int] ,
		[DeletedProtocol] [int] ,
		[ErrorId] [int] 
)	ON [PRIMARY]

PRINT 'Table DeleteLog added'
END

GO
------------------------------------------------------------------------------------------------------------------------------------------



