
------------------------------------------------------------------------------------------------------------------------------------------
------------ DeleteParameters: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
-- Table DeleteParameters contains the parameters which control the CleanupDb routine 
IF NOT exists (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[DeleteParameters]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[DeleteParameters] (
		[Id] [int] PRIMARY KEY NOT NULL DEFAULT 1 ,
		[UnitsToDelete] [int] NOT NULL DEFAULT 2000 ,
		[CaseProtocol] [int] NOT NULL DEFAULT 0 ,
		[TimeLimitProtocol] [int] DEFAULT 48 ,
		[UnitsToKeep] [int] NOT NULL DEFAULT 5000 ,
		[CaseMain] [int] NOT NULL DEFAULT 0 , 
		[TimeLimitMain] [int] DEFAULT 60 ,
		[RenewLimits] [tinyint] NOT NULL DEFAULT 1 
	) ON [PRIMARY]
	INSERT INTO [dbo].[DeleteParameters] DEFAULT VALUES ;

PRINT 'Table DeleteParameters added'
END
ELSE 
BEGIN 
	PRINT 'Table DeleteParameters already exists.' 
	IF ((SELECT COUNT(Id) FROM DeleteParameters) = 0)
	BEGIN
		INSERT INTO DeleteParameters DEFAULT VALUES
	END
END
GO
------------------------------------------------------------------------------------------------------------------------------------------


