------------------------------------------------------------------------------------------------------------------------------------------
------------ ErrorData: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[ErrorData]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[ErrorData] (
		[FkIdent]	[int]	NOT NULL,  -- Nummer der Messung
		[Nr]		[int]	NOT NULL,  -- Nummer der Grenzwertberschreitung
		[FkInternCode]	[int]	NOT NULL,  -- Verweis nach ErrorCodes
		[FkMode]	[smallint]	NOT NULL,
		[FkChannel]	[smallint] 	NOT NULL,
		[FkLocation]	[smallint]	NOT NULL,
		[FkInstrument]	[smallint]	NOT NULL,
		[FkParameter]	[smallint]	NOT NULL,
		[FehlerWert]	[float]	NOT NULL,
		[FehlerGrenze]	[float]	NOT NULL,
		[FehlerPosition][float]	NOT NULL,
		[FkUnit]	[int]	NOT NULL
	) ON [PRIMARY]

PRINT 'Table ErrorData added'
END
ELSE PRINT 'Table ErrorData already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ErrorData: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'PK_ErrorData')
BEGIN
		ALTER TABLE [dbo].[ErrorData] WITH NOCHECK ADD 
		CONSTRAINT [PK_ErrorData] PRIMARY KEY CLUSTERED 
		(
			[FkIdent],
			[Nr]
		)  ON [PRIMARY]

PRINT 'Table constraint PK_ErrorData added'
END
ELSE PRINT 'Table constraint PK_ErrorData already exists'
GO

IF EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'UQ_ErrorData')
BEGIN
	ALTER TABLE [dbo].[ErrorData] DROP CONSTRAINT [UQ_ErrorData]

PRINT 'Constraint UQ_ErrorData was dropped from table ErrorData'
END
GO
------------------------------------------------------------------------------------------------------------------------------------------

