------------------------------------------------------------------------------------------------------------------------------------------
------------ ErrorPriorityInfo: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[ErrorPriorityInfo]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
 	CREATE TABLE [dbo].[ErrorPriorityInfo] (
		[FkIdent]	[int] NOT NULL,
		[Nr]		[int] NOT NULL,
		[Priority]	[int] NOT NULL
	) ON [PRIMARY]

PRINT 'Table ErrorPriorityInfo added'
END
ELSE PRINT 'Table ErrorPriorityInfo already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ErrorPriorityInfo: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'PK_ErrorPriorityInfo')
BEGIN
	ALTER TABLE [dbo].[ErrorPriorityInfo] WITH NOCHECK ADD 
	CONSTRAINT [PK_ErrorPriorityInfo] PRIMARY KEY CLUSTERED 
		(
			[FkIdent],
			[Nr]
		)  ON [PRIMARY]

PRINT 'Table constraint PK_ErrorPriorityInfo added'
END
ELSE PRINT 'Table constraint PK_ErrorPriorityInfo already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------


