
------------------------------------------------------------------------------------------------------------------------------------------
------------ ProtocolData: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[ProtocolData]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[ProtocolData] (
		[FkIdent]	[int]	NOT NULL,
		[FkMode]	[smallint]	NOT NULL,
		[FkChannel]	[smallint] 	NOT NULL,
		[FkLocation]	[smallint]	NOT NULL,
		[FkInstrument]	[smallint]	NOT NULL,
		[FkParameter]	[smallint]	NOT NULL,
		[Value]		[real]	NOT NULL,
		[ULimit]	[real]	NOT NULL,
		[LLimit]	[real]	NOT NULL,
		[Position]	[real]	NOT NULL,
		[FkUnit]	[smallint]	NOT NULL,
		[FkExtra]	[smallint]	NOT NULL
	) ON [Protocol]

	PRINT 'Table ProtocolData added'

	CREATE UNIQUE CLUSTERED INDEX [CI_ProtocolData] ON [dbo].[ProtocolData]
	(
		[FkIdent] ASC,
		[FkMode]  ASC,
		[FkChannel]  ASC,
		[FkLocation]  ASC,
		[FkInstrument] ASC,						
		[FkParameter]  ASC

	) ON [Protocol]

	PRINT 'Unique clustered index CI_ProtocolData added'

END
ELSE PRINT 'Table ProtocolData already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------




