
------------------------------------------------------------------------------------------------------------------------------------------
------------ ShiftTimes: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[ShiftTimes]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	CREATE TABLE [dbo].[ShiftTimes] 
	(
		[ShiftId]	[int] NOT NULL,
		[Name]		[nvarchar] (50)	COLLATE Latin1_General_CI_AS NULL,
		[StartTime]	[datetime] 	NULL,
		[StopTime]	[datetime] 	NULL 
	) ON [PRIMARY]

PRINT 'Table ShiftTimes added'
END
ELSE PRINT 'Table ShiftTimes already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ShiftTimes: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT CONSTRAINT_NAME from INFORMATION_SCHEMA.KEY_COLUMN_USAGE WHERE TABLE_NAME ='ShiftTimes' AND COLUMN_NAME = 'ShiftId')
BEGIN
------------ ShiftTimes  Check Primary Key, else create. Assumes that the ShiftTimes index is Pk_ShiftTimes
	ALTER TABLE [dbo].[ShiftTimes] WITH NOCHECK 
	ADD CONSTRAINT [Pk_ShiftTimes] PRIMARY KEY CLUSTERED 
	(
		[ShiftId]
	 )  ON [PRIMARY] 

PRINT 'Table constraint Pk_ShiftTimes added'
END
ELSE PRINT 'Table constraint Pk_ShiftTimes already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------


