
------------------------------------------------------------------------------------------------------------------------------------------
------------ TimeLimitOfTypes: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
-- Table TimeLimitOfTypes contains the information on the number of units (per type and/or per bench) to be deleted by the procedure DeleteData (CleanupDb)

-- If TimeLimitsOfTypes contains a 'Transferred'-column, then it is an old ShrinkDb table. In this case, drop the old table. 
IF ((SELECT name FROM sys.columns WHERE object_id = (SELECT object_id FROM sys.objects WHERE name = 'TimeLimitsOfTypes') AND name = 'Transferred') IS NOT NULL)
BEGIN
	DROP TABLE [dbo].[TimeLimitsOfTypes]
END
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[TimeLimitsOfTypes]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN

	DECLARE @count int
	SELECT @count = (SELECT Count(Id) FROM TimeLimitsOfTypes)

	IF (@count = 0) BEGIN
		DROP TABLE [dbo].[TimeLimitsOfTypes]
		CREATE TABLE [dbo].[TimeLimitsOfTypes] (
			[Id] [int] NOT NULL ,
			[Name] [nvarchar] (50) COLLATE Latin1_General_CI_AS NULL ,
			[BenchId] [int] NULL ,
			[BenchName] [nvarchar] (50) COLLATE Latin1_General_CI_AS NULL ,
			[ActualTimeLimit] [datetime] ,
			[PreviousTimeLimit] [datetime] ,
			[UnitsToDelete] [int] ,
			[UnitsRetained] [int],
			[Deleted] [int] DEFAULT 0
		) ON [PRIMARY]
		PRINT 'Table TimeLimitsOfTypes added'
	END 
	ELSE BEGIN 
			PRINT 'Table TimeLimitsOfTypes with entries already exists.'
			IF ((SELECT name FROM sys.columns WHERE object_id = (SELECT object_id FROM sys.objects WHERE name = 'TimeLimitsOfTypes') AND name = 'BenchId') IS NULL)
			BEGIN
				ALTER TABLE [TimeLimitsOfTypes]
				ADD BenchId int NULL 
				ALTER TABLE [TimeLimitsOfTypes]
				ADD BenchName nvarchar(50) COLLATE Latin1_General_CI_AS NULL 
			END
		END
END
ELSE BEGIN
	CREATE TABLE [dbo].[TimeLimitsOfTypes] (
		[Id] [int] NOT NULL ,
		[Name] [nvarchar] (50) COLLATE Latin1_General_CI_AS NULL ,
		[BenchId] [int] NULL ,
		[BenchName] [nvarchar] (50) COLLATE Latin1_General_CI_AS NULL ,
		[ActualTimeLimit] [datetime] ,
		[PreviousTimeLimit] [datetime] ,
		[UnitsToDelete] [int] ,
		[UnitsRetained] [int],
		[Deleted] [int] DEFAULT 0
	) ON [PRIMARY]
	PRINT 'Table TimeLimitsOfTypes added'
END

GO
------------------------------------------------------------------------------------------------------------------------------------------
