
------------------------------------------------------------------------------------------------------------------------------------------
------------ TypeClassId: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[TypeClassId]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[TypeClassId] 
	(
		[Id]		[int] not null,
		[Text]		[nvarchar] (80)	COLLATE Latin1_General_CI_AS NULL 
	) ON [PRIMARY]
	
PRINT 'Table TypeClassId added'
END
ELSE PRINT 'Table TypeClassId already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ TypeClassId: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT CONSTRAINT_NAME from INFORMATION_SCHEMA.KEY_COLUMN_USAGE WHERE TABLE_NAME ='TypeClassId' AND COLUMN_NAME = 'Id')
BEGIN
------------ TypeClassId  Check Primary Key, else create. Assumes that the TypeClassId index is Pk_TypeClassId
	ALTER TABLE [dbo].[TypeClassId] WITH NOCHECK 
	ADD CONSTRAINT [Pk_TypeClassId] PRIMARY KEY  CLUSTERED
	(
		[Id]
	 )  ON [PRIMARY] 

PRINT 'Table constraint Pk_TypeClassId added'
END
ELSE PRINT 'Table constraint Pk_TypeClassId already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

