
------------------------------------------------------------------------------------------------------------------------------------------
------------ TypeID: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[TypeId]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[TypeId] (
		[Id] 		[int]		PRIMARY KEY  CLUSTERED NOT NULL,
		[Name] 		[nvarchar] (50)	COLLATE Latin1_General_CI_AS NULL,
		[LongName] 	[nvarchar] (50)	COLLATE Latin1_General_CI_AS NULL,
		[BaseType] 	[int]		NOT NULL,
		[TypeClass] [int] 		NOT NULL 
	) ON [PRIMARY]
	
PRINT 'Table TypeId added'
END
ELSE PRINT 'Table TypeId already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ TypeId: Check constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS  (SELECT CONSTRAINT_NAME from INFORMATION_SCHEMA.KEY_COLUMN_USAGE WHERE TABLE_NAME ='TypeId' AND COLUMN_NAME = 'Id')
BEGIN
	ALTER TABLE [dbo].[TypeId] WITH NOCHECK ADD 
		CONSTRAINT [Pk_TypeId] PRIMARY KEY  CLUSTERED
		(
			[Id]
		)  ON [PRIMARY] 

PRINT 'Table constraint Pk_TypeId added'
END
ELSE PRINT 'Table constraint Pk_TypeId already exists'
GO

IF ((SELECT dbo.fnDsDefConstraintName('TypeId','BaseType')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[TypeId] WITH NOCHECK ADD CONSTRAINT [DF_TypeID_BaseType]	DEFAULT (0) FOR [BaseType]

PRINT 'Table constraint DF_TypeID_BaseType added'
END
ELSE PRINT 'Table constraint DF_TypeID_BaseType already exists'
GO

IF ((SELECT dbo.fnDsDefConstraintName('TypeId','TypeClass')) IS NULL) 
BEGIN
	ALTER TABLE [dbo].[TypeId] WITH NOCHECK ADD CONSTRAINT [DF_TypeID_TypeClass] DEFAULT (0) FOR [TypeClass]

PRINT 'Table constraint DF_TypeID_TypeClass added'
END
ELSE PRINT 'Table constraint DF_TypeID_TypeClass already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------




