
------------------------------------------------------------------------------------------------------------------------------------------
------------ WeeklyResultDetails: Check existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[WeeklyResultDetails]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].[WeeklyResultDetails] (
		[WeekNr]					[int]		NOT NULL,
		[Type]						[int]		NOT NULL,	
		[TestBench]					[int]		NOT NULL,	
		[CountType]					[int]		NOT NULL,	
		[All]						[int]		NULL,
		[Good]						[int]		NULL,
		[Bad]						[int]		NULL
	) ON [PRIMARY]

PRINT 'Table WeeklyResultDetails added'
END
ELSE PRINT 'Table WeeklyResultDetails already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ WeeklyResultDetails: Check index existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM sysindexes WHERE name = N'Idx_WeeklyResultDetails')
BEGIN
 	CREATE UNIQUE INDEX [Idx_WeeklyResultDetails] ON [dbo].WeeklyResultDetails 
	(
		[WeekNr],
		[Type],
		[TestBench],
		[CountType]		
	) ON [PRIMARY]

PRINT 'Clustered index Idx_WeeklyResultDetails added'
END
ELSE PRINT 'Clustered index Idx_WeeklyResultDetails already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

