------------------------------------------------------------------------------------------------------------------------------------------
------------ AceErrorSelection: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_AceErrorSelection_ErrorGroup')
BEGIN
	ALTER TABLE [dbo].[AceErrorSelection] WITH CHECK
	ADD CONSTRAINT [FK_AceErrorSelection_ErrorGroup] FOREIGN KEY([GroupId])
	REFERENCES [dbo].[AceErrorGroup]([Id])
	ON DELETE CASCADE
	ON UPDATE CASCADE
	
PRINT 'Added FK constraint FK_AceErrorSelection_ErrorGroup'
END
ELSE PRINT 'FK constraint FK_AceErrorSelection_ErrorGroup already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ AdditionalInfo: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_AdditionalInfo_MainData')
BEGIN
	ALTER TABLE [dbo].[AdditionalInfo] 
	ADD CONSTRAINT [FK_AdditionalInfo_MainData] FOREIGN KEY([FkIdent])
	REFERENCES [dbo].[MainData]([PkIdent])

PRINT 'Added FK constraint FK_AceErrorSelection_ErrorGroup'
END
ELSE PRINT 'FK constraint FK_AceErrorSelection_ErrorGroup already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_AdditionalInfo_AdditionalKeys')
BEGIN
	ALTER TABLE [dbo].[AdditionalInfo] 
	ADD CONSTRAINT [FK_AdditionalInfo_AdditionalKeys] FOREIGN KEY([KeyId])
	REFERENCES [dbo].[AdditionalKeys]([Id])

PRINT 'Added FK constraint FK_AdditionalInfo_AdditionalKeys'
END
ELSE PRINT 'FK constraint FK_AdditionalInfo_AdditionalKeys already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_AdditionalInfo_AdditionalValues')
BEGIN
	ALTER TABLE [dbo].[AdditionalInfo] 
	ADD CONSTRAINT [FK_AdditionalInfo_AdditionalValues]	FOREIGN KEY([ValueId])
	REFERENCES [dbo].[AdditionalValues]([Id])

PRINT 'Added FK constraint FK_AdditionalInfo_AdditionalValues'
END
ELSE PRINT 'FK constraint FK_AdditionalInfo_AdditionalValues already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ArchiveData: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ArchiveData_MainData')
BEGIN
	ALTER TABLE [dbo].[ArchiveData] 
	ADD CONSTRAINT [FK_ArchiveData_MainData] FOREIGN KEY([FkIdent])
	REFERENCES [dbo].[MainData]([PkIdent])

PRINT 'Added FK constraint FK_ArchiveData_MainData'
END
ELSE PRINT 'FK constraint FK_ArchiveData_MainData already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ArchiveData_StoreModules')
BEGIN
	ALTER TABLE [dbo].[ArchiveData] 
	ADD CONSTRAINT [FK_ArchiveData_StoreModules] FOREIGN KEY([FkStoreModule])
	REFERENCES [dbo].[StoreModules]([Id])

PRINT 'Added FK constraint FK_ArchiveData_StoreModules'
END
ELSE PRINT 'FK constraint FK_ArchiveData_StoreModules already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ArchiveData_Quinters')
BEGIN
	ALTER TABLE [dbo].[ArchiveData]
	ADD CONSTRAINT [FK_ArchiveData_Quinters] FOREIGN KEY([FkQuinter])
	REFERENCES [dbo].[Quinters]([Id])

PRINT 'Added FK constraint FK_ArchiveData_Quinters'
END
ELSE PRINT 'FK constraint FK_ArchiveData_Quinters already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ArchiveData_Files')
BEGIN
	ALTER TABLE [dbo].[ArchiveData] 
	ADD CONSTRAINT [FK_ArchiveData_Files] FOREIGN KEY([FkFilename])
	REFERENCES [dbo].[Files]([Id])

PRINT 'Added FK constraint FK_ArchiveData_Files'
END
ELSE PRINT 'FK constraint FK_ArchiveData_Files already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BaseTypeID: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE TABLE_NAME = 'BaseTypeId' AND COLUMN_NAME = 'TypeClass')
BEGIN
	ALTER TABLE [dbo].[BaseTypeId] 
	ADD CONSTRAINT [FK_BaseTypeID_TypeClassID] FOREIGN KEY([TypeClass])
	REFERENCES [dbo].[TypeClassId]([ID])

PRINT 'Added FK constraint FK_BaseTypeID_TypeClassID'
END
ELSE PRINT 'FK constraint FK_BaseTypeID_TypeClassID already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BenchID: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_BenchID_BenchGroupID')
BEGIN
	ALTER TABLE [dbo].[BenchId] 
	ADD CONSTRAINT [FK_BenchID_BenchGroupID] FOREIGN KEY([BenchGroup])
	REFERENCES [dbo].[BenchGroupId]([Id])

PRINT 'Added FK constraint FK_BenchID_BenchGroupID'
END
ELSE PRINT 'FK constraint FK_BenchID_BenchGroupID already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BlobData: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_BlobData_BlobType')
BEGIN
	ALTER TABLE [dbo].[BlobData] 
	ADD CONSTRAINT [FK_BlobData_BlobType] FOREIGN KEY([BlobType])
	REFERENCES [dbo].[BlobType]([Id])

PRINT 'Added FK constraint FK_BlobData_BlobType'
END
ELSE PRINT 'FK constraint FK_BlobData_BlobType already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_BlobData_MainData')
BEGIN
	ALTER TABLE [dbo].[BlobData] 
	ADD CONSTRAINT [FK_BlobData_MainData] FOREIGN KEY([FKident])
	REFERENCES [dbo].[MainData]([PkIdent])
	ON DELETE CASCADE
	ON UPDATE CASCADE

PRINT 'Added FK constraint FK_BlobData_MainData'
END
ELSE PRINT 'FK constraint FK_BlobData_MainData already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ BlobInfo: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_BlobInfo_BackupMedium')
BEGIN
	ALTER TABLE [dbo].[BlobInfo] 
	ADD CONSTRAINT [FK_BlobInfo_BackupMedium] FOREIGN KEY([BackupMedium])
	REFERENCES [dbo].[BackupMedium]([Id])

PRINT 'Added FK constraint FK_BlobInfo_BackupMedium'
END
ELSE PRINT 'FK constraint FK_BlobInfo_BackupMedium already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_BlobInfo_BlobStatus')
BEGIN
	ALTER TABLE [dbo].[BlobInfo] 
	ADD CONSTRAINT [FK_BlobInfo_BlobStatus] FOREIGN KEY([BackupStatus])
	REFERENCES [dbo].[BlobStatus]([Id])

PRINT 'Added FK constraint FK_BlobInfo_BlobStatus'
END
ELSE PRINT 'FK constraint FK_BlobInfo_BlobStatus already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_BlobInfo_BlobType')
BEGIN
	ALTER TABLE [dbo].[BlobInfo] 
	ADD CONSTRAINT [FK_BlobInfo_BlobType] FOREIGN KEY([BlobType])
	REFERENCES [dbo].[BlobType]([Id])

PRINT 'Added FK constraint FK_BlobInfo_BlobType'
END
ELSE PRINT 'FK constraint FK_BlobInfo_BlobType already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_BlobInfo_MainData')
BEGIN
	ALTER TABLE [dbo].[BlobInfo] 
	ADD CONSTRAINT [FK_BlobInfo_MainData] FOREIGN KEY([FkIdent])
	REFERENCES [dbo].[MainData]([PkIdent])
	ON DELETE CASCADE
	ON UPDATE CASCADE

PRINT 'Added FK constraint FK_BlobInfo_MainData'
END
ELSE PRINT 'FK constraint FK_BlobInfo_MainData already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ErrorCategoryMapping: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ErrorCategoryMapping_ErrorCodes')
BEGIN
	ALTER TABLE [dbo].[ErrorCategoryMapping] 
	ADD CONSTRAINT [FK_ErrorCategoryMapping_ErrorCodes] FOREIGN KEY([FkInternCode])
	REFERENCES [dbo].[ErrorCodes]([PkInternCode]) 
	ON UPDATE CASCADE 
	ON DELETE CASCADE

PRINT 'Added FK constraint FK_ErrorCategoryMapping_ErrorCodes'
END
ELSE PRINT 'FK constraint FK_ErrorCategoryMapping_ErrorCodes already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ErrorCategoryMapping_ErrorCategoryCodes')
BEGIN
	ALTER TABLE [dbo].[ErrorCategoryMapping] 
	ADD CONSTRAINT [FK_ErrorCategoryMapping_ErrorCategoryCodes] FOREIGN KEY([FkCategoryCode])
	REFERENCES [dbo].[ErrorCategoryCodes]([Id]) 
	ON UPDATE CASCADE 
	ON DELETE CASCADE

PRINT 'Added FK constraint FK_ErrorCategoryMapping_ErrorCategoryCodes'
END
ELSE PRINT 'FK constraint FK_ErrorCategoryMapping_ErrorCategoryCodes already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ErrorCategoryMapping: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ErrorData_MainData')
BEGIN
	ALTER TABLE [dbo].[ErrorData] 
	ADD CONSTRAINT [FK_ErrorData_MainData] FOREIGN KEY([FkIdent])
	REFERENCES [dbo].[MainData]([PkIdent])

PRINT 'Added FK constraint FK_ErrorData_MainData'
END
ELSE PRINT 'FK constraint FK_ErrorData_MainData already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ErrorData_ModeId')
BEGIN
	ALTER TABLE [dbo].[ErrorData] 
	ADD CONSTRAINT [FK_ErrorData_ModeId] FOREIGN KEY([FkMode])
	REFERENCES [dbo].[ModeId]([Id])

PRINT 'Added FK constraint FK_ErrorData_ModeId'
END
ELSE PRINT 'FK constraint FK_ErrorData_ModeId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ErrorData_InstanceId')
BEGIN
	ALTER TABLE [dbo].[ErrorData] 
	ADD CONSTRAINT [FK_ErrorData_InstanceId] FOREIGN KEY([FkChannel])
	REFERENCES [dbo].[InstanceId]([Id])

PRINT 'Added FK constraint FK_ErrorData_InstanceId'
END
ELSE PRINT 'FK constraint FK_ErrorData_InstanceId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ErrorData_LocationId')
BEGIN
	ALTER TABLE [dbo].[ErrorData] 
	ADD CONSTRAINT [FK_ErrorData_LocationId] FOREIGN KEY([FkLocation])
	REFERENCES [dbo].[LocationId]([Id])

PRINT 'Added FK constraint FK_ErrorData_LocationId'
END
ELSE PRINT 'FK constraint FK_ErrorData_LocationId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ErrorData_InstrumentId')
BEGIN
	ALTER TABLE [dbo].[ErrorData] 
	ADD CONSTRAINT [FK_ErrorData_InstrumentId] FOREIGN KEY([FkInstrument])
	REFERENCES [dbo].[InstrumentId]([Id])

PRINT 'Added FK constraint FK_ErrorData_InstrumentId'
END
ELSE PRINT 'FK constraint FK_ErrorData_InstrumentId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ErrorData_InstrParamId')
BEGIN
	ALTER TABLE [dbo].[ErrorData] 
	ADD CONSTRAINT [FK_ErrorData_InstrParamId] FOREIGN KEY([FkParameter])
	REFERENCES [dbo].[InstrParamId]([Id])

PRINT 'Added FK constraint FK_ErrorData_InstrParamId'
END
ELSE PRINT 'FK constraint FK_ErrorData_InstrParamId already exists'
GO
		
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ErrorData_ErrorCodes')
BEGIN
	ALTER TABLE [dbo].[ErrorData] 
	ADD CONSTRAINT [FK_ErrorData_ErrorCodes] FOREIGN KEY([FkInternCode])
	REFERENCES [dbo].[ErrorCodes]([PkInternCode])

PRINT 'Added FK constraint FK_ErrorData_ErrorCodes'
END
ELSE PRINT 'FK constraint FK_ErrorData_ErrorCodes already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ErrorPriorityInfo: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ErrorPriorityInfo_ErrorData')
BEGIN
	ALTER TABLE [dbo].[ErrorPriorityInfo] 
	ADD CONSTRAINT [FK_ErrorPriorityInfo_ErrorData] FOREIGN KEY([FkIdent], [Nr])
	REFERENCES [dbo].[ErrorData]([FkIdent], [Nr]) 
	ON UPDATE CASCADE 
	ON DELETE CASCADE

PRINT 'Added FK constraint FK_ErrorData_MainData'
END
ELSE PRINT 'FK constraint FK_ErrorData_MainData already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ MainData: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_MainData_BaseTypeID')
BEGIN
	ALTER TABLE [dbo].[MainData] 
	ADD CONSTRAINT [FK_MainData_BaseTypeID] FOREIGN KEY([BaseType])
	REFERENCES [dbo].[BaseTypeId]([Id])

PRINT 'Added FK constraint FK_MainData_BaseTypeID'
END
ELSE PRINT 'FK constraint FK_MainData_BaseTypeID already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_MainData_BenchID')
BEGIN
	ALTER TABLE [dbo].[MainData] 
	ADD CONSTRAINT [FK_MainData_BenchID] FOREIGN KEY([TestBench])
	REFERENCES [dbo].[BenchId]([Id])

PRINT 'Added FK constraint FK_MainData_BenchID'
END
ELSE PRINT 'FK constraint FK_MainData_BenchID already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_MainData_FactoryID')
BEGIN
	ALTER TABLE [dbo].[MainData] 
	ADD CONSTRAINT [FK_MainData_FactoryID] FOREIGN KEY([Factory])
	REFERENCES [dbo].[FactoryId]([ID])

PRINT 'Added FK constraint FK_MainData_FactoryID'
END
ELSE PRINT 'FK constraint FK_MainData_FactoryID already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_MainData_ResultID')
BEGIN
	ALTER TABLE [dbo].[MainData] 
	ADD CONSTRAINT [FK_MainData_ResultID] FOREIGN KEY([Result])
	REFERENCES [dbo].[ResultId]([Id])

PRINT 'Added FK constraint FK_MainData_ResultID'
END
ELSE PRINT 'FK constraint FK_MainData_ResultID already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_MainData_TestTypeID')
BEGIN
	ALTER TABLE [dbo].[MainData] 
	ADD CONSTRAINT [FK_MainData_TestTypeID] FOREIGN KEY([TestKind])
	REFERENCES [dbo].[TestKindId]([Id])

PRINT 'Added FK constraint FK_MainData_TestTypeID'
END
ELSE PRINT 'FK constraint FK_MainData_TestTypeID already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_MainData_TypeClassID')
BEGIN
	ALTER TABLE [dbo].[MainData] 
	ADD CONSTRAINT [FK_MainData_TypeClassID] FOREIGN KEY([TypeClass])
	REFERENCES [dbo].[TypeClassId]([ID])

PRINT 'Added FK constraint FK_MainData_TypeClassID'
END
ELSE PRINT 'FK constraint FK_MainData_TypeClassID already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_MainData_TypeID')
BEGIN
	ALTER TABLE [dbo].[MainData] 
	ADD CONSTRAINT [FK_MainData_TypeID] FOREIGN KEY([Type])	
	REFERENCES [dbo].[TypeId]([Id])
	ON DELETE CASCADE
	ON UPDATE CASCADE

PRINT 'Added FK constraint FK_MainData_TypeID'
END
ELSE PRINT 'FK constraint FK_MainData_TypeID already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ModesPerMeasurement: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ModesPerMeasurement_ModeId')
BEGIN
	ALTER TABLE [dbo].[ModesPerMeasurement] 
	ADD CONSTRAINT [FK_ModesPerMeasurement_ModeId] FOREIGN KEY([FkMode])
	REFERENCES [dbo].[ModeId]([Id])

PRINT 'Added FK constraint FK_ModesPerMeasurement_ModeId'
END
ELSE PRINT 'FK constraint FK_ModesPerMeasurement_ModeId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ModesPerMeasurement_MainData')
BEGIN
	ALTER TABLE [dbo].[ModesPerMeasurement] 
	ADD CONSTRAINT [FK_ModesPerMeasurement_MainData] FOREIGN KEY([FkIdent])
	REFERENCES [dbo].[MainData]([PkIdent])

PRINT 'Added FK constraint FK_ModesPerMeasurement_MainData'
END
ELSE PRINT 'FK constraint FK_ModesPerMeasurement_MainData already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ProtocolCrossReference: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolCrossReference_InstanceId')
BEGIN
	ALTER TABLE [dbo].[ProtocolCrossReference] 
	ADD CONSTRAINT [FK_ProtocolCrossReference_InstanceId] FOREIGN KEY([FkInstance])
	REFERENCES [dbo].[InstanceId]([Id])

PRINT 'Added FK constraint FK_ProtocolCrossReference_InstanceId'
END
ELSE PRINT 'FK constraint FK_ProtocolCrossReference_InstanceId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolCrossReference_InstrParamId')
BEGIN
	ALTER TABLE [dbo].[ProtocolCrossReference] 
	ADD CONSTRAINT [FK_ProtocolCrossReference_InstrParamId] FOREIGN KEY([FkParam])
	REFERENCES [dbo].[InstrParamId]([Id])

PRINT 'Added FK constraint FK_ProtocolCrossReference_InstrParamId'
END
ELSE PRINT 'FK constraint FK_ProtocolCrossReference_InstrParamId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolCrossReference_InstrumentId')
BEGIN
	ALTER TABLE [dbo].[ProtocolCrossReference] 
	ADD CONSTRAINT [FK_ProtocolCrossReference_InstrumentId] FOREIGN KEY([FkInstrument])
	REFERENCES [dbo].[InstrumentId]([Id])

PRINT 'Added FK constraint FK_ProtocolCrossReference_InstrumentId'
END
ELSE PRINT 'FK constraint FK_ProtocolCrossReference_InstrumentId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolCrossReference_LocationId')
BEGIN
	ALTER TABLE [dbo].[ProtocolCrossReference] 
	ADD CONSTRAINT [FK_ProtocolCrossReference_LocationId] FOREIGN KEY([FkLocation])
	REFERENCES [dbo].[LocationId]([Id])

PRINT 'Added FK constraint FK_ProtocolCrossReference_LocationId'
END
ELSE PRINT 'FK constraint FK_ProtocolCrossReference_LocationId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolCrossReference_ModeId')
BEGIN
	ALTER TABLE [dbo].[ProtocolCrossReference] 
	ADD CONSTRAINT [FK_ProtocolCrossReference_ModeId] FOREIGN KEY([FkMode])
	REFERENCES [dbo].[ModeId]([Id])

PRINT 'Added FK constraint FK_ProtocolCrossReference_ModeId'
END
ELSE PRINT 'FK constraint FK_ProtocolCrossReference_ModeId already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ProtocolData: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_MainData')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] 
	ADD CONSTRAINT [FK_ProtocolData_MainData] FOREIGN KEY([FkIdent])
	REFERENCES [dbo].[MainData]([PkIdent])

PRINT 'Added FK constraint FK_ProtocolData_MainData'
END
ELSE PRINT 'FK constraint FK_ProtocolData_MainData already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_ModeId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] 
	ADD CONSTRAINT [FK_ProtocolData_ModeId] FOREIGN KEY([FkMode])
	REFERENCES [dbo].[ModeId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_ModeId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_ModeId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_InstanceId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] 
	ADD CONSTRAINT [FK_ProtocolData_InstanceId] FOREIGN KEY([FkChannel])
	REFERENCES [dbo].[InstanceId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_InstanceId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_InstanceId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_LocationId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] 
	ADD CONSTRAINT [FK_ProtocolData_LocationId] FOREIGN KEY([FkLocation])
	REFERENCES [dbo].[LocationId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_LocationId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_LocationId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_InstrumentId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData]
	ADD CONSTRAINT [FK_ProtocolData_InstrumentId] FOREIGN KEY([FkInstrument])
	REFERENCES [dbo].[InstrumentId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_InstrumentId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_InstrumentId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_InstrParamId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] 
	ADD CONSTRAINT [FK_ProtocolData_InstrParamId] FOREIGN KEY([FkParameter])
	REFERENCES [dbo].[InstrParamId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_InstrParamId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_InstrParamId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_UnitId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] 
	ADD CONSTRAINT [FK_ProtocolData_UnitId] FOREIGN KEY([FkUnit])
	REFERENCES [dbo].[UnitId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_UnitId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_UnitId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_ExtraPInfoId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] 
	ADD CONSTRAINT [FK_ProtocolData_ExtraPInfoId] FOREIGN KEY([FkExtra])
	REFERENCES [dbo].[ExtraPInfoId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_ExtraPInfoId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_ExtraPInfoId already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ Referenzgetriebe: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_Referenzgetriebe_TypeID')
BEGIN
	ALTER TABLE [dbo].[Referenzgetriebe] 
	ADD CONSTRAINT [FK_Referenzgetriebe_TypeID] FOREIGN KEY([Type])
	REFERENCES [dbo].[TypeID]([Id])

PRINT 'Added FK constraint FK_Referenzgetriebe_TypeID'
END
ELSE PRINT 'FK constraint FK_Referenzgetriebe_TypeID already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------


------------------------------------------------------------------------------------------------------------------------------------------
------------ ShiftMinutes: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ShiftMinutes_ShiftNames')
BEGIN
	ALTER TABLE [dbo].[ShiftMinutes] WITH CHECK 
	ADD CONSTRAINT [FK_ShiftMinutes_ShiftNames] FOREIGN KEY([ShiftId])
	REFERENCES [dbo].[ShiftNames] ([Id])
	ON UPDATE CASCADE
	ON DELETE CASCADE
PRINT 'Added FK constraint FK_ShiftMinutes_ShiftNames'
END
ELSE PRINT 'FK constraint FK_ShiftMinutes_ShiftNames already exists'
GO

ALTER TABLE [dbo].[ShiftMinutes] CHECK CONSTRAINT [FK_ShiftMinutes_ShiftNames]
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ TypeID: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS  (SELECT * FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE  WHERE TABLE_NAME = 'TypeId' AND COLUMN_NAME = 'BaseType')
BEGIN
	ALTER TABLE [dbo].[TypeId] 
	ADD CONSTRAINT [FK_TypeID_BaseTypeID] FOREIGN KEY([BaseType])
	REFERENCES [dbo].[BaseTypeId]([Id])
	
PRINT 'Added FK constraint FK_TypeID_BaseTypeID'
END
ELSE PRINT 'FK constraint FK_TypeID_BaseTypeID already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ WeeklyResultDetails: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_WeeklyResultDetails_BenchID')
BEGIN
	ALTER TABLE [dbo].WeeklyResultDetails 
	ADD CONSTRAINT [FK_WeeklyResultDetails_BenchID] FOREIGN KEY([TestBench])
	REFERENCES [dbo].[BenchId]([Id])

PRINT 'Added FK constraint FK_WeeklyResultDetails_BenchID'
END
ELSE PRINT 'FK constraint FK_WeeklyResultDetails_BenchID already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_WeeklyResultDetails_TypeID')
BEGIN
	ALTER TABLE [dbo].WeeklyResultDetails 
	ADD CONSTRAINT [FK_WeeklyResultDetails_TypeID] FOREIGN KEY([Type])
	REFERENCES [dbo].[TypeId]([Id])

PRINT 'Added FK constraint FK_WeeklyResultDetails_TypeID'
END
ELSE PRINT 'FK constraint FK_WeeklyResultDetails_TypeID already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_WeeklyResultDetails_CountID')
BEGIN
	ALTER TABLE [dbo].WeeklyResultDetails 
	ADD CONSTRAINT [FK_WeeklyResultDetails_CountID] FOREIGN KEY([CountType])
	REFERENCES [dbo].[ResultCountType]([Id])

PRINT 'Added FK constraint FK_WeeklyResultDetails_CountID'
END
ELSE PRINT 'FK constraint FK_WeeklyResultDetails_CountID already exists'
GO

------------------------------------------------------------------------------------------------------------------------------------------