
----------------------------------------------------------------------------------------------------------------------------
------------ AceErrorGroup: Default entries
----------------------------------------------------------------------------------------------------------------------------
DECLARE 
	@nrGroups int

SELECT @nrGroups = count ( * ) from AceErrorGroup

IF (@nrGroups = 0) 
BEGIN
	PRINT 'No entries in table AceErrorGroup. Setting Default Values'
	INSERT INTO [AceErrorGroup] VALUES (100, 'Acoustic Rejects')
	INSERT INTO [AceErrorGroup] VALUES (200, 'Function Rjects')
	INSERT INTO [AceErrorGroup] VALUES (900, 'System Rejects')
	INSERT INTO [AceErrorGroup] VALUES (1100, 'Extra quiet transmissions')
END
ELSE PRINT 'Table AceErrorGroup already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ BenchGroupID: Default entries
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM [BenchGroupId] WHERE Id = 0) 
BEGIN 
	PRINT 'No entries in table BenchGroupID. Setting Default Values'
	INSERT INTO [BenchGroupId] VALUES ('*')
	IF NOT EXISTS (SELECT * FROM [BenchGroupId] WHERE Id = 1) INSERT INTO [BenchGroupId] VALUES ('Standard')
END
ELSE PRINT 'Table BenchGroupID already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ FactoryId: Default entries
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM [FactoryId] WHERE id = 0) 
BEGIN
	PRINT 'No entries in table FactoryId. Setting Default Values'
	INSERT INTO [FactoryId] VALUES (0, '*')
	IF NOT EXISTS (SELECT * FROM [FactoryId] WHERE id = 1) INSERT INTO [FactoryId] VALUES (1, 'Standard')
END
ELSE PRINT 'Table FactoryId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ Quinters: Default entries
----------------------------------------------------------------------------------------------------------------------------
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[Quinters]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	IF ((SELECT COUNT(*) FROM [dbo].Quinters) = 0)
	BEGIN
		PRINT 'No entries in table Quinters. Setting Default Values'
		INSERT INTO Quinters VALUES ('','','','','')	-- Id = 0, All values = ''.
	END
	ELSE PRINT 'Table Quinters already contains entries'
END
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ ResultCountType: Default entries
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM [ResultCountType] WHERE id = 0) 
BEGIN
	PRINT 'No entries in table ResultCountType. Setting Default Values'
	IF NOT EXISTS (SELECT * FROM [ResultCountType] WHERE id = 1) INSERT INTO [ResultCountType] VALUES (1, 'All')
	IF NOT EXISTS (SELECT * FROM [ResultCountType] WHERE id = 2) INSERT INTO [ResultCountType] VALUES (2, 'Last')
	IF NOT EXISTS (SELECT * FROM [ResultCountType] WHERE id = 3) INSERT INTO [ResultCountType] VALUES (3, 'First')
	IF NOT EXISTS (SELECT * FROM [ResultCountType] WHERE id = 4) INSERT INTO [ResultCountType] VALUES (4, 'CurrentReject')
	IF NOT EXISTS (SELECT * FROM [ResultCountType] WHERE id = 5) INSERT INTO [ResultCountType] VALUES (5, 'Direct')
END
ELSE PRINT 'Table ResultCountType already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ ResultId: Default entries
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT * FROM [ResultId] WHERE id = 0) 
BEGIN
	PRINT 'No entries in table ResultId. Setting Default Values'
	INSERT INTO [ResultId] VALUES (0, '*')
	IF NOT EXISTS (SELECT * FROM [ResultId] WHERE id = 1) INSERT INTO [ResultId] VALUES (1, 'Good')
	IF NOT EXISTS (SELECT * FROM [ResultId] WHERE id = 2) INSERT INTO [ResultId] VALUES (2, 'Bad')
	IF NOT EXISTS (SELECT * FROM [ResultId] WHERE id = 3) INSERT INTO [ResultId] VALUES (3, 'Not Evaluated')
	IF NOT EXISTS (SELECT * FROM [ResultId] WHERE id = 4) INSERT INTO [ResultId] VALUES (4, 'System Error')
END
ELSE PRINT 'Table ResultId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ ShiftNames: Default entries
----------------------------------------------------------------------------------------------------------------------------
DECLARE 
	@nrShifts int

SELECT @nrShifts = count ( * ) from ShiftNames

IF (@nrShifts = 0) 
BEGIN
	PRINT 'No entries in table ShiftNames. Setting Default Values'
	INSERT INTO [ShiftNames] VALUES (1, 'Morning')
	INSERT INTO [ShiftNames] VALUES (2, 'Day')
	INSERT INTO [ShiftNames] VALUES (3, 'Night')
END
ELSE PRINT 'Table ShiftNames already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ ShiftMinutes: Default entries
----------------------------------------------------------------------------------------------------------------------------
DECLARE 
	@nrShifts int

SELECT @nrShifts = count ( * ) from [ShiftMinutes]

IF (@nrShifts = 0) 
BEGIN
	PRINT 'No entries in table ShiftMinutes. Setting Default Values'
	INSERT INTO [ShiftMinutes] VALUES (1, 3, 0, 390, 1, '1,2,3,4,5,6,7')
	INSERT INTO [ShiftMinutes] VALUES (2, 1, 390, 870, 0, '1,2,3,4,5,6,7')
	INSERT INTO [ShiftMinutes] VALUES (3, 2, 870, 1350, 0, '1,2,3,4,5,6,7')
	INSERT INTO [ShiftMinutes] VALUES (4, 3, 1350, 1440, 0, '1,2,3,4,5,6,7')
END
ELSE PRINT 'Table ShiftMinutes already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ StoreModules: Default entry
----------------------------------------------------------------------------------------------------------------------------
-- Einfgen des speziellen Werts Null: Wurzel des Storage-Modul-Baums
IF NOT EXISTS (SELECT * FROM [StoreModules] WHERE id = 0) 
BEGIN
	PRINT 'No entries in table StoreModules. Setting Default Values'
	INSERT INTO StoreModules VALUES ('')	-- Id = 0, Name = ''.
END
ELSE PRINT 'Table StoreModules already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ TypeClassId: Default entries !!!!!!! Order is crucial: TypeClassId before BaseTypeId before TypeId !!!!!!!!!!!!
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT Id FROM [TypeClassId] WHERE Id = 0)
BEGIN
	PRINT 'No entries in table TypeClassId. Setting Default Values'
	INSERT INTO [TypeClassId] VALUES (0, '*')
	IF NOT EXISTS (SELECT Id FROM [TypeClassId] WHERE Id = 1) INSERT INTO [TypeClassId] VALUES (1, 'Not Assigned')
END
ELSE PRINT 'Table TypeClassId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ BaseTypeId: Default entries !!!!!!! Order is crucial: TypeClassId before BaseTypeId before TypeId !!!!!!!!!!!!
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT Id FROM [BaseTypeId] WHERE Id = 0)
BEGIN
	PRINT 'No entries in table BaseTypeId. Setting Default Values'
	INSERT INTO [BaseTypeId] (text, typeClass)  VALUES ('*', 0)
END
ELSE PRINT 'Table BaseTypeId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ TypeId default entries !!!!!!!!!!! Order is crucial: TypeClassId before BaseTypeId before TypeId !!!!!!!!!!!!!!
----------------------------------------------------------------------------------------------------------------------------
IF  NOT EXISTS (SELECT Id FROM [TypeId] WHERE Id = 0)
BEGIN
	PRINT 'No entries in table TypeId. Setting Default Values'
	INSERT INTO [TypeId] VALUES (0, '*', '*', 0, 0)
END
ELSE PRINT 'Table TypeId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ BenchId default entries
----------------------------------------------------------------------------------------------------------------------------
IF  NOT EXISTS (SELECT Id FROM [BenchId] WHERE Id = 0)
BEGIN
	PRINT 'No entries in table BenchId. Setting Default Values'
	INSERT INTO [BenchId] VALUES (0, '*', '*', 0)
END
ELSE PRINT 'Table BenchId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ Referenzgetriebe default entries
----------------------------------------------------------------------------------------------------------------------------
IF  NOT EXISTS (SELECT Type FROM [Referenzgetriebe] WHERE Type = 0)
BEGIN
	PRINT 'No entries in table Referenzgetriebe. Setting Default Values'
	INSERT INTO [Referenzgetriebe] VALUES (0, 0, '*')
END
ELSE PRINT 'Table Referenzgetriebe already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ InstanceId default entries
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT Id FROM [InstanceId] WHERE Id = 0)
BEGIN
	PRINT 'No entries in table InstanceId. Setting Default Values'
	INSERT INTO [InstanceId] VALUES ('?')
END
ELSE PRINT 'Table InstanceId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ InstrParamId default entries
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT Id FROM [InstrParamId] WHERE Id = 0)
BEGIN
	PRINT 'No entries in table InstrParamId. Setting Default Values'
	INSERT INTO [InstrParamId] VALUES ('?')
END
ELSE PRINT 'Table InstrParamId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ InstrumentId default entries
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT Id FROM [InstrumentId] WHERE Id = 0)
BEGIN
	PRINT 'No entries in table InstrumentId. Setting Default Values'
	INSERT INTO [InstrumentId] VALUES ('?')
END
ELSE PRINT 'Table InstrumentId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ LocationId default entries
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT Id FROM [LocationId] WHERE Id = 0)
BEGIN
	PRINT 'No entries in table LocationId. Setting Default Values'
	INSERT INTO [LocationId] VALUES ('?')
END
ELSE PRINT 'Table LocationId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ ModeId default entries
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT Id FROM [ModeId] WHERE Id = 0)
BEGIN
	PRINT 'No entries in table ModeId. Setting Default Values'
	INSERT INTO [ModeId] VALUES ('?')
END
ELSE PRINT 'Table ModeId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------------
------------ ExtraPInfoId default entries
----------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT Id FROM [ExtraPInfoId] WHERE Id = 0)
BEGIN
	PRINT 'No entries in table ExtraPInfoId. Setting Default Values'
	INSERT INTO [ExtraPInfoId] VALUES (0, '?')
	IF NOT EXISTS (SELECT Id FROM [ExtraPInfoId] WHERE Id = 1) INSERT INTO [ExtraPInfoId] VALUES (1, '')
END
ELSE PRINT 'Table ExtraPInfoId already contains entries'
GO
----------------------------------------------------------------------------------------------------------------------------
