

------------------------------------------------------------------------------------------------------------------------------------------
------------ 1. Drop all foreign key constraints
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ WeeklyResultDetails: Check and drop foreign key constraint existence
------------------------------------------------------------------------------------------------------------------------------------------
IF EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_WeeklyResultDetails_BenchID')
	ALTER TABLE [dbo].WeeklyResultDetails 
	DROP CONSTRAINT [FK_WeeklyResultDetails_BenchID] 
GO

IF EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_WeeklyResultDetails_TypeID')
	ALTER TABLE [dbo].WeeklyResultDetails 
	DROP CONSTRAINT [FK_WeeklyResultDetails_TypeID] 
GO

IF EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_WeeklyResultDetails_CountID')
	ALTER TABLE [dbo].WeeklyResultDetails 
	DROP CONSTRAINT [FK_WeeklyResultDetails_CountID] 
GO
------------------------------------------------------------------------------------------------------------------------------------------


------------------------------------------------------------------------------------------------------------------------------------------
------------ 2. Truncate all tables
------------------------------------------------------------------------------------------------------------------------------------------


IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[ResultCountType]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	TRUNCATE TABLE [dbo].[ResultCountType]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[WeeklyResultDetails]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	TRUNCATE TABLE [dbo].[WeeklyResultDetails]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[WeeklyResults]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
	TRUNCATE TABLE [dbo].[WeeklyResults]
GO
------------------------------------------------------------------------------------------------------------------------------------------


------------------------------------------------------------------------------------------------------------------------------------------
------------ 3. Re-add foreign key constraints
------------------------------------------------------------------------------------------------------------------------------------------


------------------------------------------------------------------------------------------------------------------------------------------
------------ WeeklyResultDetails: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_WeeklyResultDetails_BenchID')
BEGIN
	ALTER TABLE [dbo].WeeklyResultDetails 
	ADD CONSTRAINT [FK_WeeklyResultDetails_BenchID] FOREIGN KEY([TestBench])
	REFERENCES [dbo].[BenchId]([Id])

PRINT 'Added FK constraint FK_WeeklyResultDetails_BenchID'
END
ELSE PRINT 'FK constraint FK_WeeklyResultDetails_BenchID already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_WeeklyResultDetails_TypeID')
BEGIN
	ALTER TABLE [dbo].WeeklyResultDetails 
	ADD CONSTRAINT [FK_WeeklyResultDetails_TypeID] FOREIGN KEY([Type])
	REFERENCES [dbo].[TypeId]([Id])

PRINT 'Added FK constraint FK_WeeklyResultDetails_TypeID'
END
ELSE PRINT 'FK constraint FK_WeeklyResultDetails_TypeID already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_WeeklyResultDetails_CountID')
BEGIN
	ALTER TABLE [dbo].WeeklyResultDetails 
	ADD CONSTRAINT [FK_WeeklyResultDetails_CountID] FOREIGN KEY([CountType])
	REFERENCES [dbo].[ResultCountType]([Id])

PRINT 'Added FK constraint FK_WeeklyResultDetails_CountID'
END
ELSE PRINT 'FK constraint FK_WeeklyResultDetails_CountID already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
