

------------------------------------------------------------------------------------------------------------------------------------------
------------ ShiftTimes: Drop and re-create trigger tr_Insert_ShiftTimes
------------------------------------------------------------------------------------------------------------------------------------------
IF EXISTS (SELECT 'True' FROM sysobjects WHERE name = 'tr_Insert_ShiftTimes' AND type = 'TR')
DROP TRIGGER tr_Insert_ShiftTimes
GO

CREATE TRIGGER tr_Insert_ShiftTimes ON ShiftTimes
INSTEAD OF INSERT
AS
BEGIN
--	SELECT * FROM INSERTED
	DECLARE @name 	NVARCHAR (50)
	DECLARE @begin 	DATETIME
	DECLARE @end 	DATETIME

	SET @name	= (SELECT [Name] 	FROM INSERTED)
	SET @begin	= CONVERT(DATETIME, '01.01.2000 ' + CAST((SELECT DATEPART(HOUR, [StartTime]) FROM INSERTED) AS NVARCHAR) + ':' + CAST((SELECT DATEPART(MINUTE, [StartTime]) FROM INSERTED) AS NVARCHAR) + ':' + CAST((SELECT DATEPART(SECOND, [StartTime]) FROM INSERTED) AS NVARCHAR), 120)
	SET @end	= CONVERT(DATETIME, '01.01.2000 ' + CAST((SELECT DATEPART(HOUR, [StopTime]) FROM INSERTED) AS NVARCHAR) + ':' + CAST((SELECT DATEPART(MINUTE, [StopTime]) FROM INSERTED) AS NVARCHAR) + ':' + CAST((SELECT DATEPART(SECOND, [StopTime]) FROM INSERTED) AS NVARCHAR), 120)

	INSERT INTO ShiftTimes ([Name], [StartTime], [StopTime]) VALUES (@name, @begin, @end)
END
GO
------------------------------------------------------------------------------------------------------------------------------------------

------------------------------------------------------------------------------------------------------------------------------------------
------------ ShiftTimes: Drop and re-create trigger tr_Update_ShiftTimes
------------------------------------------------------------------------------------------------------------------------------------------
IF EXISTS (SELECT 'True' FROM sysobjects WHERE name = 'tr_Update_ShiftTimes' AND type = 'TR')
DROP TRIGGER tr_Update_ShiftTimes
GO

CREATE TRIGGER tr_Update_ShiftTimes ON ShiftTimes
INSTEAD OF UPDATE
AS
BEGIN
--	SELECT * FROM INSERTED
	DECLARE @id 	INT
	DECLARE @name 	NVARCHAR (50)
	DECLARE @begin 	DATETIME
	DECLARE @end 	DATETIME

	SET @id		= (SELECT [ShiftId] 	FROM INSERTED)
	SET @name	= (SELECT [Name] 	FROM INSERTED)
	SET @begin	= CONVERT(DATETIME, '01.01.2000 ' + CAST((SELECT DATEPART(HOUR, [StartTime]) FROM INSERTED) AS NVARCHAR) + ':' + CAST((SELECT DATEPART(MINUTE, [StartTime]) FROM INSERTED) AS NVARCHAR) + ':' + CAST((SELECT DATEPART(SECOND, [StartTime]) FROM INSERTED) AS NVARCHAR), 120)
	SET @end	= CONVERT(DATETIME, '01.01.2000 ' + CAST((SELECT DATEPART(HOUR, [StopTime]) FROM INSERTED) AS NVARCHAR) + ':' + CAST((SELECT DATEPART(MINUTE, [StopTime]) FROM INSERTED) AS NVARCHAR) + ':' + CAST((SELECT DATEPART(SECOND, [StopTime]) FROM INSERTED) AS NVARCHAR), 120)

	UPDATE ShiftTimes SET [Name] 		= @name  	WHERE [ShiftId] = @id
	UPDATE ShiftTimes SET [StartTime] 	= @begin  	WHERE [ShiftId] = @id
	UPDATE ShiftTimes SET [StopTime] 	= @end  	WHERE [ShiftId] = @id
END
GO
------------------------------------------------------------------------------------------------------------------------------------------