

------------------------------------------------------------------------------------------------------------------------------------------
------------ View: ErrorMainVsCategory
------------------------------------------------------------------------------------------------------------------------------------------

-- Roland, 23.06.05
-- Diese View beinhaltet Daten zur Fehlerauswertung nach Fehlerkategorien

IF EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.VIEWS WHERE TABLE_NAME = 'ErrorMainVsCategory')
DROP VIEW [dbo].[ErrorMainVsCategory]
GO

CREATE VIEW [dbo].[ErrorMainVsCategory]
AS

SELECT
	[dbo].[MainData].[PkIdent],
	[dbo].[MainData].[Serial],
	[dbo].[MainData].[Ordinal],
	[dbo].[MainData].[Result],
	[dbo].[MainData].[Type],
	[dbo].[MainData].[BaseType],
	[dbo].[MainData].[TestBench],
	[dbo].[BenchID].[BenchGroup],
	[dbo].[MainData].[Time],
	[dbo].[MainData].[TimeOfNextMeasurement],
	[dbo].[MainData].[TestKind],
	[dbo].[MainData].[ThisLast],
	[dbo].[ErrorData].[Nr],
	[dbo].[ErrorData].[FkInternCode],
	[dbo].[ErrorCategoryMapping].[FkCategoryCode],
	[dbo].[ErrorData].[FkMode],
	[dbo].[ErrorData].[FkChannel],
	[dbo].[ErrorData].[FkLocation],
	[dbo].[ErrorData].[FkInstrument],
	[dbo].[ErrorData].[FkParameter],
	[dbo].[ErrorData].[FehlerWert],
	[dbo].[ErrorData].[FehlerGrenze],
	[dbo].[ErrorData].[FehlerPosition],
	[dbo].[ErrorData].[FkUnit]
FROM
	[dbo].[ErrorData]
INNER JOIN [dbo].[MainData] 		ON [dbo].[ErrorData].[FkIdent] 		= [dbo].[MainData].[PkIdent]
INNER JOIN [dbo].[BenchID] 		ON [dbo].[MainData].[TestBench] 	= [dbo].[BenchID].[Id]
INNER JOIN [dbo].[ErrorCategoryMapping] ON [dbo].[ErrorData].[FkInternCode]	= [dbo].[ErrorCategoryMapping].[FkInternCode]
GO
PRINT 'View ErrorMainVsCategory was re-created'
------------------------------------------------------------------------------------------------------------------------------------------
