

------------------------------------------------------------------------------------------------------------------------------------------
------------ View: vwShortErrorReport
------------------------------------------------------------------------------------------------------------------------------------------

IF EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.VIEWS WHERE TABLE_NAME = 'vwShortErrorReport')
	DROP VIEW [dbo].[vwShortErrorReport]
GO

CREATE VIEW [dbo].[vwShortErrorReport]
AS

SELECT

-- Basic measurement information:

 BenchId.[LongName]		AS TestBench,
 TypeId.[LongName]		AS Type,
 BaseTypeId.[Text]		AS BaseType,
 MainData.[Serial],
 MainData.[Time],
 MainData.[ThisLast],

-- Single error information:

 ErrorData.[FkInternCode]	AS ErrorCode,
 ErrorCodes.[Text]		AS ErrorText,
 ErrorCategoryMapping.[FkCategoryCode]	AS ErrorCategoryCode,
 ErrorCategoryCodes.[Text]	AS ErrorCategoryText,
 ErrorData.Nr			AS Nr,
 ModeId.[Text]			AS Mode,
 ErrorData.[FehlerWert]		AS Value,
 ErrorData.[FehlerGrenze]	AS Limit,
 UnitId.[Text]			AS Unit,
 InstrumentId.[Text]		AS Instrument,
 InstanceId.[Text]		AS Channel,
 ErrorData.[FehlerPosition]	AS Position

FROM

 ErrorData

INNER JOIN ErrorCodes 		ON ErrorCodes.[PkInternCode]	= ErrorData.[FkInternCode] 
INNER JOIN ErrorCategoryMapping	ON ErrorCategoryMapping.[FkInternCode]	= ErrorData.[FkInternCode]
INNER JOIN ErrorCategoryCodes	ON ErrorCategoryCodes.[Id]	= ErrorCategoryMapping.[FkCategoryCode]
INNER JOIN MainData		ON MainData.[PkIdent]		= ErrorData.[FkIdent]

INNER JOIN TypeId 		ON TypeId.[Id] 			= MainData.[Type]
INNER JOIN BaseTypeId 		ON BaseTypeId.[Id] 		= MainData.[BaseType]
INNER JOIN BenchId 		ON BenchId.[Id] 		= MainData.[TestBench]

INNER JOIN ModeId 		ON ModeId.[Id]			= ErrorData.[FkMode] 
INNER JOIN InstanceId 		ON InstanceId.[Id]		= ErrorData.[FkChannel]
INNER JOIN InstrumentId 	ON InstrumentId.[Id]		= ErrorData.[FkInstrument]
INNER JOIN UnitId 		ON UnitId.[Id]			= ErrorData.[FkUnit]

GO
PRINT 'View vwShortErrorProtocol was re-created'
------------------------------------------------------------------------------------------------------------------------------------------