

-- If copy table is not empty, check its entries and calculate the related number of ProtocolData-entries
IF ((SELECT SUM(UnitsRetained) FROM xTimeLimitsOfTypes) <> 0)
BEGIN
	RAISERROR ('Checking ProtocolData for specified time limits of types...', 0, 1) WITH NOWAIT
	
	---------------------------------------------------------------------------------------------------------------------------------------------
	-- TYPE AND BENCH SPECIFIC
	---------------------------------------------------------------------------------------------------------------------------------------------
	IF ((SELECT Count(BenchId) FROM TimeLimitsOfTypes WHERE BenchId IS NOT NULL) <> 0) 
	BEGIN

	DECLARE 
			@lim_id int, 
			@lim_name varchar(50),
			@bench_id int, 
			@bench_name varchar(50),
			@lim_limitTime dateTime,
			@lim_Transferred int,
			@duration int, 
			@unitsProt bigint,
			@lineMessage varchar(300),
			@intErrorCode int,
			@del_Start dateTime,
			@count bigint,
			@message varchar(300)

		DECLARE lim_cursor CURSOR FOR 
		SELECT Id, Name, BenchId, BenchName, LimitTime, Transferred, Duration, UnitsProtocol
		FROM xTimeLimitsOfTypes
		WHERE LimitTime IS NOT NULL AND Transferred = 0
		ORDER BY Id, BenchId

		OPEN lim_cursor

		FETCH NEXT FROM lim_cursor 
		INTO @lim_id, @lim_name, @bench_id, @bench_name, @lim_limitTime, @lim_Transferred, @duration, @unitsProt 

		WHILE @@FETCH_STATUS = 0
		BEGIN

		   BEGIN TRAN
				
				SELECT @count = (SELECT COUNT(FkIdent) FROM ProtocolData INNER JOIN MainData ON FkIdent = PkIdent 
								 WHERE MainData.Type = @lim_id AND MainData.TestBench = @bench_id 
								 AND MainData.Time >= @lim_limitTime)

    			IF (@count <> 0) GOTO QUIT

    			UPDATE [xTimeLimitsOfTypes]
    			SET UnitsProtocol = @count
    			WHERE xTimeLimitsOfTypes.Id = @lim_id AND xTimeLimitsOfTypes.BenchId = @bench_id
    			SELECT @intErrorCode = @@ERROR	
				IF (@intErrorCode <> 0) GOTO PROBLEM

			COMMIT TRAN

			-- ROLLBACK TRAN
			PROBLEM:
			IF (@intErrorCode <> 0) BEGIN
			  PRINT 'Unexpected error occurred!'
			  ROLLBACK TRAN
			END

			-- Get the next line.
			FETCH NEXT FROM lim_cursor 
			INTO @lim_id, @lim_name, @bench_id, @bench_name, @lim_limitTime, @lim_Transferred, @duration, @unitsProt

		END

		CLOSE lim_cursor
		DEALLOCATE lim_cursor

		-- Check entries
		IF ((SELECT SUM(UnitsProtocol) FROM xTimeLimitsOfTypes) = 0) RAISERROR ('No data to be copied to xProtocolData. Continuing will remove all single values data.',6,1) WITH NOWAIT

		QUIT: 
		IF (@count <> 0) BEGIN
			RAISERROR ('The units to be copied contain ProtocolData entries.', 3, 1) WITH NOWAIT
			CLOSE lim_cursor
			DEALLOCATE lim_cursor
		END
	END

	---------------------------------------------------------------------------------------------------------------------------------------------
	-- TYPE SPECIFIC
	---------------------------------------------------------------------------------------------------------------------------------------------
	ELSE
	BEGIN

	DECLARE 
			@lim_id2 int, 
			@lim_name2 varchar(50),
			@bench_id2 int, 
			@bench_name2 varchar(50),
			@lim_limitTime2 dateTime,
			@lim_Transferred2 int,
			@duration2 int, 
			@unitsProt2 bigint,
			@lineMessage2 varchar(300),
			@intErrorCode2 int,
			@del_Start2 dateTime,
			@count2 bigint,
			@message2 varchar(300)

		DECLARE lim_cursor2 CURSOR FOR 
		SELECT Id, Name, BenchId, BenchName, LimitTime, Transferred, Duration, UnitsProtocol
		FROM xTimeLimitsOfTypes
		WHERE LimitTime IS NOT NULL AND Transferred = 0
		ORDER BY Id, BenchId

		OPEN lim_cursor2

		FETCH NEXT FROM lim_cursor2 
		INTO @lim_id2, @lim_name2, @bench_id2, @bench_name2, @lim_limitTime2, @lim_Transferred2, @duration2, @unitsProt2

		WHILE @@FETCH_STATUS = 0
		BEGIN

		   BEGIN TRAN
				
				SELECT @count2 = (SELECT COUNT(FkIdent) FROM ProtocolData INNER JOIN MainData ON FkIdent = PkIdent 
								 WHERE MainData.Type = @lim_id2 AND MainData.Time >= @lim_limitTime2)

    			IF (@count2 <> 0) GOTO QUIT2

    			UPDATE [xTimeLimitsOfTypes]
    			SET UnitsProtocol = @count2
    			WHERE xTimeLimitsOfTypes.Id = @lim_id2
    			SELECT @intErrorCode2 = @@ERROR	
				IF (@intErrorCode2 <> 0) GOTO PROBLEM2

			COMMIT TRAN

			-- ROLLBACK TRAN
			PROBLEM2:
			IF (@intErrorCode2 <> 0) BEGIN
			  PRINT 'Unexpected error occurred!'
			  ROLLBACK TRAN
			END

			-- Get the next line.
			FETCH NEXT FROM lim_cursor2
			INTO @lim_id2, @lim_name2, @bench_id2, @bench_name2, @lim_limitTime2, @lim_Transferred2, @duration2, @unitsProt2

		END

		CLOSE lim_cursor2
		DEALLOCATE lim_cursor2

		-- Check entries
		IF ((SELECT SUM(UnitsProtocol) FROM xTimeLimitsOfTypes) = 0) RAISERROR ('No data to be copied to xProtocolData. Continuing will remove all single values data.',6,1) WITH NOWAIT

		QUIT2: 
		IF (@count2 <> 0) BEGIN
			RAISERROR ('The units to be copied contain ProtocolData entries.', 3, 1) WITH NOWAIT
			CLOSE lim_cursor2
			DEALLOCATE lim_cursor2
		END
	END

END
ELSE RAISERROR ('No data to be copied to xProtocolData. Continuing will remove all single values data.',6,1) WITH NOWAIT

GO
---------------------------------------------------------------------------------------------------------------------------------------------
