
PRINT 'Creating unique clustered index on xProtocolData...'
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[xProtocolData]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	IF NOT EXISTS (SELECT * FROM sysindexes WHERE name = N'CI_ProtocolData')
	BEGIN
 		CREATE UNIQUE CLUSTERED INDEX [CI_ProtocolData] ON [dbo].[xProtocolData]
		(
			[FkIdent] ASC,
			[FkMode]  ASC,
			[FkChannel]  ASC,
			[FkLocation]  ASC,
			[FkInstrument] ASC,						
			[FkParameter]  ASC

		) ON [Protocol]
		PRINT 'Added clustered index CI_ProtocolData'
	END
	ELSE PRINT 'Clustered index CI_ProtocolData already exists'
END
ELSE RAISERROR ('Table xProtocolData does not exist. Please create first in order to create indexes.',11,1) WITH NOWAIT
GO


