
PRINT 'Updating TimeLimitsOfTypes...'
GO

---------------------------------------------------------------------------------------------------------------------------------------------
-- TYPE AND BENCH SPECIFIC
---------------------------------------------------------------------------------------------------------------------------------------------
IF ((SELECT Count(BenchId) FROM TimeLimitsOfTypes WHERE BenchId IS NOT NULL) <> 0)
BEGIN
---------------------------------------------------------------------------------------------------------------------------------------------
-- Replace previous time limits with the time limits from the Shrink operation
---------------------------------------------------------------------------------------------------------------------------------------------
	
	UPDATE [TimeLimitsOfTypes]  
	SET TimeLimitsOfTypes.PreviousTimeLimit = (SELECT LimitTime 
		FROM xTimeLimitsOfTypes 
		WHERE xTimeLimitsOfTypes.Id = TimeLimitsOfTypes.Id 
		AND xTimeLimitsOfTypes.BenchId = TimeLimitsOfTypes.BenchId) 
	WHERE Id <> 0

---------------------------------------------------------------------------------------------------------------------------------------------
-- Substitute null values
---------------------------------------------------------------------------------------------------------------------------------------------
	UPDATE [TimeLimitsOfTypes]
	SET TimeLimitsOfTypes.PreviousTimeLimit = (SELECT MIN(Time) FROM MainData 
	WHERE Type = Id AND TestBench = BenchId) 
	WHERE TimeLimitsOfTypes.PreviousTimeLimit IS NULL

---------------------------------------------------------------------------------------------------------------------------------------------
-- Calculation of the units to delete and to keep
---------------------------------------------------------------------------------------------------------------------------------------------
	UPDATE [TimeLimitsOfTypes]
	SET UnitsToDelete = (SELECT COUNT (*) FROM MainData WHERE MainData.Type = TimeLimitsOfTypes.Id AND
	    MainData.TestBench = TimeLimitsOfTypes.BenchId AND
		MainData.Time < TimeLimitsOfTypes.ActualTimeLimit AND MainData.Time >= TimeLimitsOfTypes.PreviousTimeLimit)
	WHERE Id <> 0
	UPDATE [TimeLimitsOfTypes]
	SET UnitsRetained = (SELECT COUNT (*) FROM MainData WHERE MainData.Type = TimeLimitsOfTypes.Id AND
		MainData.TestBench = TimeLimitsOfTypes.BenchId AND 
		MainData.Time >= TimeLimitsOfTypes.ActualTimeLimit)
	WHERE Id <> 0

---------------------------------------------------------------------------------------------------------------------------------------------
-- Set renew flag of TimeLimitsOfTypes 
---------------------------------------------------------------------------------------------------------------------------------------------
-- In case there are still units left to delete, set 'Renew' in table 'DeleteParameters' to 0. 
DECLARE @count int
SELECT @count = (SELECT COUNT (*) FROM TimeLimitsOfTypes 
				WHERE TimeLimitsOfTypes.UnitsToDelete <> 0)
If (@count = 0) Begin
	Update [DeleteParameters]
	Set [RenewLimits] = 1
End

---------------------------------------------------------------------------------------------------------------------------------------------
-- Set delete flag of TimeLimitsOfTypes
---------------------------------------------------------------------------------------------------------------------------------------------
-- In case the UnitsToDelete is zero (for a given type), then set column 'Deleted' to 1 
UPDATE [TimeLimitsOfTypes]
SET Deleted = 1
WHERE TimeLimitsOfTypes.UnitsToDelete = 0

-- In case the UnitsToDelete is NOT zero (for a given type), then set column 'Deleted' to 1 
UPDATE [TimeLimitsOfTypes]
SET Deleted = 0
WHERE TimeLimitsOfTypes.UnitsToDelete <> 0
---------------------------------------------------------------------------------------------------------------------------------------------

END
---------------------------------------------------------------------------------------------------------------------------------------------
-- TYPE SPECIFIC
---------------------------------------------------------------------------------------------------------------------------------------------
ELSE
BEGIN
---------------------------------------------------------------------------------------------------------------------------------------------
-- Replace previous time limits with the time limits from the Shrink operation
---------------------------------------------------------------------------------------------------------------------------------------------
	UPDATE [TimeLimitsOfTypes]  
	SET TimeLimitsOfTypes.PreviousTimeLimit = (SELECT LimitTime FROM xTimeLimitsOfTypes WHERE xTimeLimitsOfTypes.Id = TimeLimitsOfTypes.Id) 
	WHERE Id <> 0

---------------------------------------------------------------------------------------------------------------------------------------------
-- Substitute null values
---------------------------------------------------------------------------------------------------------------------------------------------
	UPDATE [TimeLimitsOfTypes]
	SET TimeLimitsOfTypes.PreviousTimeLimit = (SELECT MIN(Time) FROM MainData WHERE Type = Id) 
	WHERE TimeLimitsOfTypes.PreviousTimeLimit IS NULL

---------------------------------------------------------------------------------------------------------------------------------------------
-- Calculation of the units to delete and to keep
---------------------------------------------------------------------------------------------------------------------------------------------
	UPDATE [TimeLimitsOfTypes]
	SET UnitsToDelete = (SELECT COUNT (*) FROM MainData WHERE MainData.Type = TimeLimitsOfTypes.Id AND
		MainData.Time < TimeLimitsOfTypes.ActualTimeLimit AND MainData.Time >= TimeLimitsOfTypes.PreviousTimeLimit)
	WHERE Id <> 0
	UPDATE [TimeLimitsOfTypes]
	SET UnitsRetained = (SELECT COUNT (*) FROM MainData WHERE MainData.Type = TimeLimitsOfTypes.Id AND
		MainData.Time >= TimeLimitsOfTypes.ActualTimeLimit)
	WHERE Id <> 0

---------------------------------------------------------------------------------------------------------------------------------------------
-- Set renew flag of TimeLimitsOfTypes 
---------------------------------------------------------------------------------------------------------------------------------------------
-- In case there are still units left to delete, set 'Renew' in table 'DeleteParameters' to 0. 
	DECLARE @count2 int
	SELECT @count2 = (SELECT COUNT (*) FROM TimeLimitsOfTypes 
					WHERE TimeLimitsOfTypes.UnitsToDelete <> 0)
	If (@count2 = 0) Begin
		Update [DeleteParameters]
		Set [RenewLimits] = 1
	End
	Else
		Update [DeleteParameters]
		Set [RenewLimits] = 0

---------------------------------------------------------------------------------------------------------------------------------------------
-- Set delete flag of TimeLimitsOfTypes
---------------------------------------------------------------------------------------------------------------------------------------------
-- In case the UnitsToDelete is zero (for a given type), then set column 'Deleted' to 1 
	UPDATE [TimeLimitsOfTypes]
	SET Deleted = 1
	WHERE TimeLimitsOfTypes.UnitsToDelete = 0

	-- In case the UnitsToDelete is NOT zero (for a given type), then set column 'Deleted' to 1 
	UPDATE [TimeLimitsOfTypes]
	SET Deleted = 0
	WHERE TimeLimitsOfTypes.UnitsToDelete <> 0
---------------------------------------------------------------------------------------------------------------------------------------------

END

PRINT 'TimeLimitsOfTypes were successfully updated'
GO