USE master;
GO

PRINT 'Setting max SQL Server memory...'
GO

EXEC sp_configure 'show advanced options', 1
GO

RECONFIGURE
GO

DECLARE @max_server_memory int

-- Set @max_server_memory to 60 % of the total physical memory installed on SQL Server
SELECT @max_server_memory = (SELECT [total_physical_memory_kb] FROM [master].[sys].[dm_os_sys_memory]) / 1024 * 0.6

EXEC sp_configure 'max server memory (MB)', @max_server_memory
RECONFIGURE
GO
