
USE DQ250_ProdDb
GO


DECLARE @start datetime,
		@end datetime, 
		@intErrorCode int,
		@monthId int,
		@message nvarchar(100)

SELECT @start = (SELECT MIN([Time]) FROM MainData WHERE YEAR([Time]) = 2017)
SELECT @end = (SELECT MAX([Time]) FROM MainData WHERE YEAR([Time]) = 2017)

IF NOT EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[CopyByMonth]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	CREATE TABLE [dbo].CopyByMonth (
		[Id]	[int] PRIMARY KEY CLUSTERED IDENTITY (1,1) NOT NULL,
		[MonthId]	[int] NOT NULL,
		[Copied]	[bit] NULL 
	) ON [PRIMARY]

PRINT 'Table CopyByMonth added'
END

IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 1) INSERT INTO CopyByMonth VALUES (1)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 2) INSERT INTO CopyByMonth VALUES (2)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 3) INSERT INTO CopyByMonth VALUES (3)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 4) INSERT INTO CopyByMonth VALUES (4)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 5) INSERT INTO CopyByMonth VALUES (5)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 6) INSERT INTO CopyByMonth VALUES (6)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 7) INSERT INTO CopyByMonth VALUES (7)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 8) INSERT INTO CopyByMonth VALUES (8)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 9) INSERT INTO CopyByMonth VALUES (9)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 10) INSERT INTO CopyByMonth VALUES (10)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 11) INSERT INTO CopyByMonth VALUES (11)
IF NOT EXISTS (SELECT Id FROM CopyByMonth WHERE MonthId = 12) INSERT INTO CopyByMonth VALUES (12)


DECLARE lim_cursor CURSOR FOR 
SELECT MonthId
FROM CopyByMonth
ORDER BY MonthId

OPEN lim_cursor

FETCH NEXT FROM lim_cursor 
INTO @monthId
		
WHILE @@FETCH_STATUS = 0
BEGIN

	SET @message = 'Copying data for month ' + CONVERT(char(10), @monthId)
	RAISERROR(@message,0,1) WITH NOWAIT

	BEGIN TRAN	
	
	INSERT INTO  [xProtocolData]

    SELECT FkIdent,FkMode,FkChannel,FkLocation,FkInstrument,FkParameter,Value,ULimit,LLimit,Position,FkUnit,FkExtra 
   	FROM [ProtocolData] INNER JOIN MainData ON ProtocolData.FkIdent = MainData.PkIdent
    WHERE MainData.[Time] >= @start AND MainData.[Time] <= @end	AND MONTH(MainData.[Time]) = @monthId
    
    SELECT @intErrorCode = @@ERROR	
	IF (@intErrorCode <> 0) GOTO PROBLEM

	COMMIT TRAN

	UPDATE CopyByMonth SET Copied = 1 
	WHERE MonthId = @monthId

	SET @message = 'Copying data for month ' + CONVERT(char(10), @monthId) + ' finished'
	RAISERROR(@message,0,1) WITH NOWAIT
	
	PROBLEM:
	IF (@intErrorCode <> 0) BEGIN
		PRINT 'Unexpected error occurred!'
		ROLLBACK TRAN
	END

	-- Get the next line.
	FETCH NEXT FROM lim_cursor 
	INTO @monthId

END

CLOSE lim_cursor
DEALLOCATE lim_cursor

PRINT 'Data copy completed'