USE DiscomData_ProdDb
GO

----------------------------------------------------------------------------------------------------------------------------
-- Rename xProtocolData
----------------------------------------------------------------------------------------------------------------------------
PRINT 'Renaming xProtocolData to ProtocolData...'
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[xProtocolData]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
BEGIN
	DECLARE @intErrorCode INT
	SELECT @intErrorCode = 0

	BEGIN TRAN
		EXEC @intErrorCode = sp_rename 'xProtocolData', 'ProtocolData'
		IF (@intErrorCode <> 0) GOTO PROBLEM
	COMMIT TRAN

	PRINT 'xProtocolData was successfully renamed to ProtocolData.'

	-- ROLLBACK TRAN
	PROBLEM:
	IF (@intErrorCode <> 0) BEGIN
	PRINT 'Unexpected error occurred!'
		ROLLBACK TRAN
	END
END
ELSE RAISERROR ('Table xProtocolData does not exist. Please create first.',11,1) WITH NOWAIT
GO

PRINT 'Creating remaining indexes on ProtocolData...'
GO
