USE DiscomData_ProdDb
GO

------------------------------------------------------------------------------------------------------------------------------------------
------------ ProtocolData: Check foreign key constraint existence, else build
------------------------------------------------------------------------------------------------------------------------------------------
IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_MainData')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] WITH NOCHECK
	ADD CONSTRAINT [FK_ProtocolData_MainData] FOREIGN KEY([FkIdent])
	REFERENCES [dbo].[MainData]([PkIdent])

PRINT 'Added FK constraint FK_ProtocolData_MainData'
END
ELSE PRINT 'FK constraint FK_ProtocolData_MainData already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_ModeId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] WITH NOCHECK
	ADD CONSTRAINT [FK_ProtocolData_ModeId] FOREIGN KEY([FkMode])
	REFERENCES [dbo].[ModeId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_ModeId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_ModeId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_InstanceId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] WITH NOCHECK
	ADD CONSTRAINT [FK_ProtocolData_InstanceId] FOREIGN KEY([FkChannel])
	REFERENCES [dbo].[InstanceId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_InstanceId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_InstanceId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_LocationId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] WITH NOCHECK
	ADD CONSTRAINT [FK_ProtocolData_LocationId] FOREIGN KEY([FkLocation])
	REFERENCES [dbo].[LocationId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_LocationId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_LocationId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_InstrumentId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] WITH NOCHECK
	ADD CONSTRAINT [FK_ProtocolData_InstrumentId] FOREIGN KEY([FkInstrument])
	REFERENCES [dbo].[InstrumentId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_InstrumentId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_InstrumentId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_InstrParamId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] WITH NOCHECK
	ADD CONSTRAINT [FK_ProtocolData_InstrParamId] FOREIGN KEY([FkParameter])
	REFERENCES [dbo].[InstrParamId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_InstrParamId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_InstrParamId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_UnitId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] WITH NOCHECK
	ADD CONSTRAINT [FK_ProtocolData_UnitId] FOREIGN KEY([FkUnit])
	REFERENCES [dbo].[UnitId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_UnitId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_UnitId already exists'
GO

IF NOT EXISTS (SELECT 'True' FROM INFORMATION_SCHEMA.CONSTRAINT_COLUMN_USAGE WHERE CONSTRAINT_NAME = 'FK_ProtocolData_ExtraPInfoId')
BEGIN
	ALTER TABLE [dbo].[ProtocolData] WITH NOCHECK
	ADD CONSTRAINT [FK_ProtocolData_ExtraPInfoId] FOREIGN KEY([FkExtra])
	REFERENCES [dbo].[ExtraPInfoId]([Id])

PRINT 'Added FK constraint FK_ProtocolData_ExtraPInfoId'
END
ELSE PRINT 'FK constraint FK_ProtocolData_ExtraPInfoId already exists'
GO
------------------------------------------------------------------------------------------------------------------------------------------
